Attribute VB_Name = "hicpd52c"
'=============================================================================
'   HPCI-cpd52c series Driver for Windows
'   I/F DLL Function
'       file name:hicpd52c.bas
'       date     :2003/06/16
'       version  :2.0.0.0
'   Copyright(C) 2001-2003
'   Hivertec Inc. All Rights Reserved.
'=============================================================================

Option Explicit
' ----------------------------------------------------------------------------
' 萔`
' ----------------------------------------------------------------------------
Public Const INVALID_BUS_NUMBER         As Long = -1    ' ȃoXԍ
Public Const INVALID_DEV_NUMBER         As Long = -1    ' ȃfoCXԍ
Public Const INVALID_IO_ADDRESS         As Long = -1    '  I/O AhX
Public Const INVALID_IRQ_NUMBER         As Long = -1    '  IRQ ԍ
Public Const INVALID_HPC_NUMBER         As Long = -1    ' ȊǗԍ
Public Const INVALID_BOARD_ID           As Long = -1    ' ȃ{[hID

' ----------------------------------------------------------------------------
' \
' ----------------------------------------------------------------------------
' foCX
Public Type HCP52CINFO          ' foCX
    dwBusNumber     As Long         ' oXԍ
    dwDeviceNumber  As Long         ' foCXԍ
    dwBaseAddress2  As Long         ' x[XAhXO
    dwBaseAddress3  As Long         ' x[XAhXP
    dwBaseAddress4  As Long         ' x[XAhXQ
    dwIrqNo         As Long         ' IRQ ԍ
    dwNumber        As Long         ' Ǘԍ(Windows 95ł͖)
    dwBoardID       As Long         ' {[hID
End Type

'------------------------------------------------------------------------------
' DLL֐vg^Cv
'------------------------------------------------------------------------------
' foCX̎擾(FfoCX̌̃AhX)
Declare Function cp52c_GetDeviceCount Lib "hicpd52c.dll" (ByRef pDevNum As Long) As Long
        
' foCX̎擾(FfoCX̌̃AhXCfoCX񃊃Xg̐擪AhX)
Declare Function cp52c_GetDeviceInfo Lib "hicpd52c.dll" (ByRef pDevNum As Long, pHpcDevInfo As HCP52CINFO) As Long
        
' foCX̃I[v(FHPCIfoCXnh̃AhXCfoCX̃AhX)
Declare Function cp52c_OpenDevice Lib "hicpd52c.dll" (ByRef hDevID As Long, pHpcDevInfo As HCP52CINFO) As Long
        
' foCX̃N[Y(FHPCIfoCXnh)
Declare Function cp52c_CloseDevice Lib "hicpd52c.dll" (ByVal hDevID As Long) As Long
                
' CXe[^XǍ(FHPCIfoCXnhCCf[^i[)
Declare Function cp52c_rMstsW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByRef nData As Integer) As Long
        
' TuXe[^XǍ(FHPCIfoCXnhCCf[^i[)
Declare Function cp52c_rSstsW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByRef nData As Integer) As Long

' R}h(FHPCIfoCXnh CCR}h)
Declare Function cp52c_wCmdW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByVal nCmd As Integer) As Long

' WX^Ǎ(FHPCIfoCXnhCCR}hCf[^i[)
Declare Function cp52c_rReg Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByVal nCmd As Integer, ByRef lData As Long) As Long

' WX^(FHPCIfoCXnhCCR}hCf[^)
Declare Function cp52c_wReg Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByVal nCmd As Integer, ByVal lData As Long) As Long
       
' IvV|[gǍ(FHPCIfoCXnhC|[gAhXCf[^i[)
Declare Function cp52c_rPortB Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAdr As Integer, ByRef byData As Byte) As Long

' IvV|[g(FHPCIfoCXnhC|[gAhXCf[^)
Declare Function cp52c_wPortB Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAdr As Integer, ByVal byData As Byte) As Long

' IvV|[gǍ(FHPCIfoCXnhC|[gAhXCf[^i[)
Declare Function cp52c_rPortW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAdr As Integer, ByVal nData As Integer) As Long

' IvV|[g(FHPCIfoCXnhC|[gAhXCf[^)
Declare Function cp52c_wPortW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAdr As Integer, ByVal nData As Integer) As Long

' o̓obt@Ǎ(FHPCIfoCXnhCCf[^i[)
Declare Function cp52c_rBufDW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByRef lData As Long) As Long

' o̓obt@(FHPCIfoCXnhCCf[^)
Declare Function cp52c_wBufDW Lib "hicpd52c.dll" (ByVal hDevID As Long, ByVal nAx As Integer, ByVal lData As Long) As Long


