'=============================================================================
'   HPCI-cpd52c series Driver for Windows
'   I/F DLL Function
'       file name:hicpd52c.vb
'       date     :2007/06/
'       version  :1.0.0.0
'   Copyright(C) 2007
'   Hivertec Inc. All Rights Reserved.
'=============================================================================
Option Strict Off
Option Explicit On

Imports System 
Imports System.Runtime.InteropServices 



Module hicpd52c
    ' ----------------------------------------------------------------------------
    ' 萔`
    ' ----------------------------------------------------------------------------
    Public Const INVALID_BUS_NUMBER As Integer = -1 ' ȃoXԍ
    Public Const INVALID_DEV_NUMBER As Integer = -1 ' ȃfoCXԍ
    Public Const INVALID_IO_ADDRESS As Integer = -1 '  I/O AhX
    Public Const INVALID_IRQ_NUMBER As Integer = -1 '  IRQ ԍ
    Public Const INVALID_HPC_NUMBER As Integer = -1 ' ȊǗԍ
    Public Const INVALID_BOARD_ID As Integer = -1 ' ȃ{[hID

    ' ----------------------------------------------------------------------------
    ' \
    ' ----------------------------------------------------------------------------
    ' foCX
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure HCP52CINFO ' foCX
        Dim dwBusNumber As Integer ' oXԍ
        Dim dwDeviceNumber As Integer ' foCXԍ
        Dim dwBaseAddress2 As Integer ' x[XAhXO
        Dim dwBaseAddress3 As Integer ' x[XAhXP
        Dim dwBaseAddress4 As Integer ' x[XAhXQ
        Dim dwIrqNo As Integer ' IRQ ԍ
        Dim dwNumber As Integer ' Ǘԍ(Windows 95ł͖)
        Dim dwBoardID As Integer ' {[hID
    End Structure

    '------------------------------------------------------------------------------
    ' DLL֐vg^Cv
    '------------------------------------------------------------------------------
    ' foCX̎擾(FfoCX̌̃AhX)
    Declare Function cp52c_GetDeviceCount Lib "hicpd52c.dll" (ByRef pDevNum As Integer) As Integer

    ' foCX̎擾(FfoCX̌̃AhXCfoCX񃊃Xg̐擪AhX)
    Declare Function cp52c_GetDeviceInfo Lib "hicpd52c.dll" (ByRef pDevNum As Integer, _
                    <Out(), MarshalAs(UnmanagedType.LPArray)> ByVal pHpcDevInfo() As HCP52CINFO) As Integer

    ' foCX̃I[v(FHPCIfoCXnh̃AhXCfoCX̃AhX)
    Declare Function cp52c_OpenDevice Lib "hicpd52c.dll" (ByRef hDevID As Integer, ByRef pHpcDevInfo As HCP52CINFO) As Integer

    ' foCX̃N[Y(FHPCIfoCXnh)
    Declare Function cp52c_CloseDevice Lib "hicpd52c.dll" (ByVal hDevID As Integer) As Integer

    ' CXe[^XǍ(FHPCIfoCXnhCCf[^i[)
    Declare Function cp52c_rMstsW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByRef nData As Short) As Integer

    ' TuXe[^XǍ(FHPCIfoCXnhCCf[^i[)
    Declare Function cp52c_rSstsW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByRef nData As Short) As Integer

    ' R}h(FHPCIfoCXnh CCR}h)
    Declare Function cp52c_wCmdW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByVal nCmd As Short) As Integer

    ' WX^Ǎ(FHPCIfoCXnhCCR}hCf[^i[)
    Declare Function cp52c_rReg Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByVal nCmd As Short, ByRef lData As Integer) As Integer

    ' WX^(FHPCIfoCXnhCCR}hCf[^)
    Declare Function cp52c_wReg Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByVal nCmd As Short, ByVal lData As Integer) As Integer

    ' IvV|[gǍ(FHPCIfoCXnhC|[gAhXCf[^i[)
    Declare Function cp52c_rPortB Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAdr As Short, ByRef byData As Byte) As Integer

    ' IvV|[g(FHPCIfoCXnhC|[gAhXCf[^)
    Declare Function cp52c_wPortB Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAdr As Short, ByVal byData As Byte) As Integer

    ' IvV|[gǍ(FHPCIfoCXnhC|[gAhXCf[^i[)
    Declare Function cp52c_rPortW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAdr As Short, ByVal nData As Short) As Integer

    ' IvV|[g(FHPCIfoCXnhC|[gAhXCf[^)
    Declare Function cp52c_wPortW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAdr As Short, ByVal nData As Short) As Integer

    ' o̓obt@Ǎ(FHPCIfoCXnhCCf[^i[)
    Declare Function cp52c_rBufDW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByRef lData As Integer) As Integer

    ' o̓obt@(FHPCIfoCXnhCCf[^)
    Declare Function cp52c_wBufDW Lib "hicpd52c.dll" (ByVal hDevID As Integer, ByVal nAx As Short, ByVal lData As Integer) As Integer

End Module
