
using System;
using System.Runtime.InteropServices;
using System.Threading;
  
/// <summary>
/// HPCI-CPD5212M Library lebel1a function for Visual C#
/// file name	:Cp52cl1a.cs
/// class name	:Cp52cl1a
/// date		:2009/12/16
/// Copyright(C) 2001-2009  Hivertec,inc. All Rights Reserved.
/// </summary>
public class Cp52cl1a
{
	// 萔`
	public const byte CP52C_ELS_PRT = 0x00;	// ELSɐI|[g
	public const byte CP52C_CP4_PRT = 0x02;	// CSTAo͐ؑփ|[g
	public const byte CP52C_CP5_PRT = 0x04;	// CSTPo͐ؑփ|[g
	public const byte CP52C_X1C_PRT = 0x06;	// CPD5212 X1-U1CMPo͐ؑփ|[g
	public const byte CP52C_X2C_PRT = 0x08;	// CPD5212 X2-U3CMPo͐ؑփ|[g
	public const byte CP52C_INT_PRT = 0x0c;	// o͋|[g
	public const byte CP52C_FIL_PRT = 0x12;	// GR[_tB^ݒ

	// ԍ
	public const ushort X1_AX =	0;
	public const ushort Y1_AX = 1;
	public const ushort Z1_AX = 2;
	public const ushort U1_AX = 3;
	public const ushort X2_AX = 4;
	public const ushort Y2_AX = 5;
	public const ushort Z2_AX = 6;
	public const ushort U2_AX = 7;
	public const ushort X3_AX = 8;
	public const ushort Y3_AX = 9;
	public const ushort Z3_AX = 10;
	public const ushort U3_AX = 11;
	public const ushort M_AX  = 12;

	/// R}h
	public const ushort NOP = 0x0000;		    
    
	/// \tgEFAZbg
	public const ushort SRST = 0x0004;
	    
	/// CTR1(w߈ʒu)Zbg
	public const ushort CTR1R = 0x0020;
	/// CTR2(@Bʒu)Zbg
	public const ushort CTR2R = 0x0021;
	/// CTR3(΍)Zbg    
	public const ushort CTR3R = 0x0022;
	/// CTR4(ėp)Zbg
	public const ushort CTR4R = 0x0023;
	
	/// SVON ON
	public const ushort SVON = 0x0018;
	/// SVON OFF    
	public const ushort SVOFF = 0x0010;		    

	/// SVRST ON
	public const ushort SVRSTON = 0x0019;

	/// SVRST OFF
	public const ushort SVRSTOFF = 0x0011;

	/// SVCTRCLMo
	public const ushort CLROUT = 0x0024;
    /// SVCTRCLMZbg
	public const ushort CLRRST = 0x0025;	    

	/// pvWX^̃LZ
	public const ushort PRECAN = 0x0026;        
	/// RCMP5pvWX^(PRCP5)̃LZ
	public const ushort PCPCAN = 0x0027;        
	/// pvWX^f[^̃Vtg
	public const ushort PRESHF = 0x002b;        
	/// RCMP5pvWX^(PRCP5)f[^̃Vtg
	public const ushort PCPSHF = 0x002c;        
	/// Rp[^ɂ鑬xp^[ύXf[^
	/// ƂēpvWX^m肵܂B
	/// ͑s
	public const ushort PRESET = 0x004f;
    
	/// PCS͑s
	public const ushort PCSON = 0x0028;
	/// LTC͑s	    
	public const ushort LTCH = 0x0029;		    
	
	/// FL葬X^[g
	public const ushort STAFL = 0x0050;
	/// FH葬X^[g    
	public const ushort STAFH = 0x0051;
	/// FH葬X^[g(FH葬->)    
	public const ushort STAFHD = 0x0052;
	/// X^[g(->FH葬->)    
	public const ushort STAUD = 0x0053;
	/// cFL葬X^[g    
	public const ushort CNTFL = 0x0054;
	/// cFH葬X^[g	    
	public const ushort CNTFH = 0x0055;
	/// cFH葬X^[g(FH葬->)		    
	public const ushort CNTD = 0x0057;		    
	/// cʉX^[g(->FH葬->)
	public const ushort CNTUD = 0x0057;
	/// STAo(X^[g)
	public const ushort CMSTA = 0x0006;
	/// STA͑s
	public const ushort SPSTA = 0x002A;		    

	/// FL葬֏uxύX
	public const ushort FCHGL = 0x0040;		    
	/// FH葬֏uxύX	
	public const ushort FCHGH = 0x0041;		    
	/// FLx܂Ō	
	public const ushort FSCHL = 0x0042;		    
	/// FHx܂ŉ	
	public const ushort FSCHH = 0x0043;		    
    
	/// ~
	public const ushort CMEMG = 0x0005;		    
	/// STPo(~)
	public const ushort CMSTP = 0x0007;
	/// ~
	public const ushort STOP = 0x0049;
	/// ~
	public const ushort SDSTP = 0x004A;		    

	/// PRMVWX^
	public const byte WPRMV = 0x80;	            
	/// PRFLWX^	
	public const byte WPRFL = 0x81;             
	/// PRFHWX^	
	public const byte WPRFH = 0x82;			    
	/// PRURWX^	
	public const byte WPRUR = 0x83;			    
	/// PRDRWX^	
	public const byte WPRDR = 0x84;			    
	/// PRMGWX^	
	public const byte WPRMG = 0x85;			    
	/// PRDPWX^	
	public const byte WPRDP = 0x86;			    
	/// PRMDWX^	
	public const byte WPRMD = 0x87;			    
	/// PRIPWX^	
	public const byte WPRIP = 0x88;			    
	/// PRUSWX^	
	public const byte WPRUS = 0x89;			    
	/// PRDSWX^	
	public const byte WPRDS = 0x8a;			    
	/// PRCP5WX^	
	public const byte WPRCP5 = 0x8b;		    
	/// PRCIWX^	
	public const byte WPRCI = 0x8c;			    
	/// RMVWX^	
	public const byte WRMV = 0x90;	            
	/// RFLWX^
	public const byte WRFL = 0x91;              
	/// RFHWX^
	public const byte WRFH = 0x92;			    
	/// RURWX^
	public const byte WRUR = 0x93;			    
	/// RDRWX^
	public const byte WRDR = 0x94;			    
	/// RMGWX^
	public const byte WRMG = 0x95;			    
	/// RDPWX^
	public const byte WRDP = 0x96;			    
	/// RMDWX^
	public const byte WRMD = 0x97;			    
	/// RIPWX^
	public const byte WRIP = 0x98;			    
	/// RUSWX^
	public const byte WRUS = 0x99;			    
	/// RDSWX^
	public const byte WRDS = 0x9a;			    
	/// RFAWX^
	public const byte WRFA = 0x9b;			    
	/// RENV1WX^
	public const byte WRENV1 = 0x9c;		    
	/// RENV2WX^
	public const byte WRENV2 = 0x9d;		    
	/// RENV3WX^
	public const byte WRENV3 = 0x9e;		    
	/// RENV4WX^
	public const byte WRENV4 = 0x9f;		    
	/// RENV5WX^
	public const byte WRENV5 = 0xa0;		    
	/// RENV6WX^
	public const byte WRENV6 = 0xa1;		    
	/// RENV7WX^
	public const byte WRENV7 = 0xa2;		    
	/// RCTR1WX^
	public const byte WRCTR1 = 0xa3;		    
	/// RCTR2WX^
	public const byte WRCTR2 = 0xa4;		    
	/// RCTR3WX^
	public const byte WRCTR3 = 0xa5;		    
	/// RCTR4WX^
	public const byte WRCTR4 = 0xa6;		    
	/// RCMP1WX^
	public const byte WRCMP1 = 0xa7;		    
	/// RCMP2WX^
	public const byte WRCMP2 = 0xa8;		    
	/// RCMP3WX^
	public const byte WRCMP3 = 0xa9;		    
	/// RCMP4WX^
	public const byte WRCMP4 = 0xaa;		    
	/// RCMP5WX^
	public const byte WRCMP5 = 0xab;		    
	/// RIRQWX^
	public const byte WRIRQ = 0xac;			    
	/// RCIWX^
	public const byte WRCI = 0xbc;
		            
	/// PRMVWX^ǂݏo
	public const byte RPRMV = 0xc0;
	/// PRFLWX^ǂݏo		    
	public const byte RPRFL = 0xc1;
	/// PRFHWX^ǂݏo		    
	public const byte RPRFH = 0xc2;
	/// PRURWX^ǂݏo		    
	public const byte RPRUR = 0xc3;			    
	/// PRDRWX^ǂݏo
	public const byte RPRDR = 0xc4;			    
	/// PRMGWX^ǂݏo
	public const byte RPRMG = 0xc5;			    
	/// PRDPWX^ǂݏo
	public const byte RPRDP = 0xc6;			    
	/// PRMDWX^ǂݏo
	public const byte RPRMD = 0xc7;			    
	/// PRMDWX^ǂݏo
	public const byte RPRIP = 0xc8;			    
	/// PRUSWX^ǂݏo
	public const byte RPRUS = 0xc9;			    
	/// PRDSWX^ǂݏo
	public const byte RPRDS = 0xca;			    
	/// PRCP5WX^ǂݏo
	public const byte RPRCP5 = 0xcb;		    
	/// PRCIWX^ǂݏo
	public const byte RPRCI = 0xcc;		        
	/// RMVWX^ǂݏo
	public const byte RRMV = 0xd0;			    
	/// RFLWX^ǂݏo
	public const byte RRFL = 0xd1;			    
	/// RFHWX^ǂݏo
	public const byte RRFH = 0xd2;			    
	/// RURWX^ǂݏo
	public const byte RRUR = 0xd3;			    
	/// RDRWX^ǂݏo
	public const byte RRDR = 0xd4;			    
	/// RMGWX^ǂݏo
	public const byte RRMG = 0xd5;			    
	/// RDPWX^ǂݏo
	public const byte RRDP = 0xd6;			    
	/// RMDWX^ǂݏo
	public const byte RRMD = 0xd7;			    
	/// RMDWX^ǂݏo
	public const byte RRIP = 0xd8;			    
	/// RUSWX^ǂݏo
	public const byte RRUS = 0xd9;			    
	/// RDSWX^ǂݏo
	public const byte RRDS = 0xda;			    
	/// RFAWX^ǂݏo
	public const byte RRFA = 0xdb;			    
	/// RENV1WX^ǂݏo
	public const byte RRENV1 = 0xdc;		    
	/// RENV2WX^ǂݏo
	public const byte RRENV2 = 0xdd;		    
	/// RENV3WX^ǂݏo
	public const byte RRENV3 = 0xde;		    
	/// RENV4WX^ǂݏo
	public const byte RRENV4 = 0xdf;		    
	/// RENV5WX^ǂݏo
	public const byte RRENV5 = 0xe0;		    
	/// RENV6WX^ǂݏo
	public const byte RRENV6 = 0xe1;		    
	/// RENV7WX^ǂݏo
	public const byte RRENV7 = 0xe2;		    
	/// RCTR1WX^ǂݏo
	public const byte RRCTR1 = 0xe3;		    
	/// RCTR2WX^ǂݏo
	public const byte RRCTR2 = 0xe4;		    
	/// RCTR3WX^ǂݏo
	public const byte RRCTR3 = 0xe5;		    
	/// RCTR4WX^ǂݏo
	public const byte RRCTR4 = 0xe6;		    
	/// RCMP1WX^ǂݏo
	public const byte RRCMP1 = 0xe7;		    
	/// RCMP2WX^ǂݏo
	public const byte RRCMP2 = 0xe8;		    
	/// RCMP3WX^ǂݏo
	public const byte RRCMP3 = 0xe9;		    
	/// RCMP4WX^ǂݏo
	public const byte RRCMP4 = 0xea;		    
	/// RCMP5WX^ǂݏo
	public const byte RRCMP5 = 0xeb;		    
	/// RIRQWX^ǂݏo
	public const byte RRIRQ = 0xec;			    
	/// RLTC1WX^ǂݏo
	public const byte RRLTC1 = 0xed;		    
	/// RLTC2WX^ǂݏo
	public const byte RRLTC2 = 0xee;		    
	/// RLTC3WX^ǂݏo
	public const byte RRLTC3 = 0xef;		    
	/// RLTC4WX^ǂݏo
	public const byte RRLTC4 = 0xf0;		    
	/// RSTSWX^ǂݏo
	public const byte RRSTS = 0xf1;			    
	/// RESTWX^ǂݏo
	public const byte RREST = 0xf2;			    
	/// RISTWX^ǂݏo
	public const byte RRIST = 0xf3;			    
	/// RPLSWX^ǂݏo
	public const byte RRPLS = 0xf4;			  
	/// RSPDWX^ǂݏo
	public const byte RRSPD = 0xf5;			    
	/// RSDCWX^ǂݏo
	public const byte RRSDC = 0xf6;			    
	/// RCIWX^ǂݏo
	public const byte RRCI = 0xfc;		        
	/// RCICWX^ǂݏo
	public const byte RRCIC = 0xfd;		        
	/// RIPSWX^ǂݏo
	public const byte RRIPS = 0xff;			    

	/// MSTS X^[gR}hݍς݃rbg
	public const ushort M_SCM = 0x0001;         
	/// MSTS 쒆rbg
	public const ushort M_RUN = 0x0002;         
	/// MSTS ~rbg
	public const ushort M_END = 0x0008;         
	/// MSTS G[񍐃rbg
	public const ushort M_ERR = 0x0010;         
	/// MSTS Cxg񍐃rbg
	public const ushort M_INT = 0x0020;         
	/// MSTS V[PXԍrbg
	public const ushort M_SCx = 0x00C0;         
	/// MSTS CMP1rbg
	public const ushort M_CMP1 = 0x0100;        
	/// MSTS CMP2rbg
	public const ushort M_CMP2 = 0x0200;        
	/// MSTS CMP3rbg
	public const ushort M_CMP3 = 0x0400;        
	/// MSTS CMP4Mrbg
	public const ushort M_CMP4 = 0x0800;        
	/// MSTS CMP5rbg
	public const ushort M_CMP5 = 0x1000;        
	/// MSTS pvWX^trbg
	public const ushort M_PRF = 0x4000;         
	/// MSTS CMP5pvWX^trbg
	public const ushort M_PDF = 0x8000;         

	/// SSTS SVONrbg
	public const ushort S_SVON = 0x0001;        
	/// SSTS SVRSTrbg
	public const ushort S_SVRS = 0x0002;        
	/// SSTS rbg
	public const ushort S_FU = 0x0100;          
	/// SSTS rbg
	public const ushort S_FD = 0x0200;          
	/// SSTS 葬쒆rbg
	public const ushort S_FC = 0x0400;          
	/// SSTS SVALMrbg
	public const ushort S_ALM = 0x0800;         
	/// SSTS +ELSrbg
	public const ushort S_PEL = 0x1000;         
	/// SSTS -ELSrbg
	public const ushort S_MEL = 0x2000;         
	/// SSTS OLSrbg
	public const ushort S_OLS = 0x4000;         
	/// SSTS DLSrbg
	public const ushort S_DLS = 0x8000;         

	/// RSTS rbg 0:+C1:-
	public const uint R_DIR = 0x00000010;       
	/// RSTS STArbg
	public const uint R_STA = 0x00000020;       
	/// RSTS STPrbg
	public const uint R_STP = 0x00000040;       
	/// RSTS EMGrbg
	public const uint R_EMG = 0x00000080;       
	/// RSTS PCSrbg
	public const uint R_PCS = 0x00000100;       
	/// RSTS SVCTRCLrbg
	public const uint R_ERC = 0x00000200;       
	/// RSTS Zrbg
	public const uint R_EZ = 0x00000400;        
	/// RSTS +DRrbg
	public const uint R_DRP = 0x00000800;       
	/// RSTS -DRrbg
	public const uint R_DRM = 0x00001000;       
	/// RSTS INPOSrbg
	public const uint R_INPOS = 0x0010000;      

	/// EST CMP1(+SLS)ɂ~
	public const uint ES_C1 = 0x00000001;
    /// EST CMP2(-SLS)ɂ~   
	public const uint ES_C2 = 0x00000002;       
	/// EST CMP3ɂ~
	public const uint ES_C3 = 0x00000004;       
	/// EST CMP4ɂ~
	public const uint ES_C4 = 0x00000008;       
	/// EST CMP5ɂ~
	public const uint ES_C5 = 0x00000010;       
	/// EST +ELSɂ~
	public const uint ES_PL = 0x00000020;       
	/// EST -ELSɂ~
	public const uint ES_ML = 0x00000040;       
	/// EST SVALMɂ~
	public const uint ES_AL = 0x00000080;       
	/// EST STPɂ~
	public const uint ES_SP = 0x00000100;       
	/// EST EMGɂ~
	public const uint ES_EM = 0x00000200;       
	/// EST DLSɂ~
	public const uint ES_SD = 0x00000400;       
	/// EST ԃf[^ُɂ~
	public const uint ES_DT = 0x00001000;       
	/// EST ԑɂ~
	public const uint ES_IP = 0x00002000;       
	/// EST pT̓obt@I[o[t[
	public const uint ES_PO = 0x00004000;       
	/// EST ԃf[^WI[o[
	public const uint ES_AO = 0x00008000;       
	/// EST GR[_MG[
	public const uint ES_EE = 0x00010000;       
	/// EST pT͐MG[
	public const uint ES_PE = 0x00020000;       

	/// IST ~
	public const uint IS_EN = 0x00000001;       
	/// IST X^[g
	public const uint IS_NN = 0x00000002;       
	/// IST pvWX^t
	public const uint IS_NM = 0x00000004;       
	/// IST PRCP5t
	public const uint IS_ND = 0x00000008;       
	/// IST Jn
	public const uint IS_US = 0x00000010;       
	/// IST I
	public const uint IS_UE = 0x00000020;       
	/// IST Jn
	public const uint IS_DS = 0x00000040;       
	/// IST I
	public const uint IS_DE = 0x00000080;       
	/// IST CMP1
	public const uint IS_C1 = 0x00000100;       
	/// IST CMP2
	public const uint IS_C2 = 0x00000200;       
	/// IST CMP3
	public const uint IS_C3 = 0x00000400;       
	/// IST CMP4
	public const uint IS_C4 = 0x00000800;       
	/// IST CMP5
	public const uint IS_C5 = 0x00001000;       
	/// IST OLSonɂ郉b`
	public const uint IS_OL = 0x00008000;       
	/// IST DLSOFFON
	public const uint IS_SD = 0x00010000;       
	/// IST +DROFFON
	public const uint IS_PD = 0x00020000;       
	/// IST -DROFFON
	public const uint IS_MD = 0x00040000;       
	/// IST STAOFFON
	public const uint IS_SA = 0x00080000;       

	/// DLSLݒrbg(PRMD)
	public const uint MD_DLSE_BIT = 0x00000100;
	/// INPOSLݒrbg(PRMD)	
	public const uint MD_INPE_BIT = 0x00000200;
	/// ݒrbg(PRMD) 		
	public const uint MD_ACC_BIT = 0x00000400;
	/// Jn_vZ@ݒrbg(PRMD) 		
	public const uint MD_SDP_BIT = 0x00002000;
	/// PCSLݒrbg(PRMD) 		
	public const uint MD_PCSE_BIT = 0x00004000;
	/// X^[gݒrbg0(PRMD) 		
	public const uint MD_MSY0_BIT = 0x00040000;
	/// X^[gݒrbg1(PRMD) 		
	public const uint MD_MSY1_BIT = 0x00080000;
	/// STP͗Lݒrbg(PRMD) 		
	public const uint MD_STPE_BIT = 0x01000000;	 		

	/// ELSoݒrbg(RENV1)
	public const uint R1_ELSM_BIT = 0x00000008;	 		
	/// DLSoݒrbg(RENV1)
	public const uint R1_DLSM_BIT = 0x00000010;	 		
	/// DLSb`ݒrbg(RENV1) 
	public const uint R1_DLLT_BIT = 0x00000020;			
	/// DLS͘_ݒrbg(RENV1)
	public const uint R1_DLSL_BIT = 0x00000040;	 		
	/// OLS͘_ݒrbg(RENV1)
	public const uint R1_OLSL_BIT = 0x00000080;	 		
	/// SVALMoݒrbg(RENV1)
	public const uint R1_ALMM_BIT = 0x00000100;	 		
	/// SVALM͘_ݒrbg(RENV1) 
	public const uint R1_ALML_BIT = 0x00000200;			
	/// ُ~SVCTRCLo͐ݒrbg(RENV1) 	
	public const uint R1_CLRE_BIT = 0x00000400;		
	/// _ASVCTRCLo͐ݒrbg(RENV1)
	public const uint R1_CLRO_BIT = 0x00000800;	 		
	/// STP͎~@ݒrbg(RENV1)
	public const uint R1_CSTP_BIT = 0x00080000; 
	/// INPOS͘_ݒrbg(RENV1)
	public const uint R1_INPL_BIT = 0x00400000;	 		
	/// PCS͘_ݒrbg(RENV1)
	public const uint R1_PCSL_BIT = 0x01000000;	 		
	/// EZ͘_ݒrbg(RENV2)
	public const uint R2_EZL_BIT = 0x00800000;	 
   
    /// sȃp[^
    public const uint ILLEGAL_PRM = 0x0100;

	/// sȃnh
    public const uint ILLEGAL_HANDLE = uint.MaxValue;

	// ELSɐI|[gf[^(16܂őΉ)
	// ELSɐI|[gf[^̓{[hǂݏoȂ
	// \tgEFAŕϐɊi[Ă
	public static ushort[] g_elspol = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

	/// <summary>
	/// WX^Ǐo
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="byCmd">WX^ǏoR}h</param>
	/// <param name="unReg">WX^ǂݏoꂽf[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_rReg(uint hDevID, ushort usAxis, byte byCmd, ref uint unReg)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		// ԍ0`11ȊO̎̓G[
		if((usAxis < X1_AX) || (usAxis < X1_AX))	return (ILLEGAL_PRM);
		
		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_rReg(hDevID, usAxis, byCmd, ref unReg);
		}
		return (unRet);
	}

	/// <summary>
	/// WX^֐
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="byCmd">WX^݃R}h</param>
	/// <param name="unReg">WX^֏ރf[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_wReg(uint hDevID, ushort usAxis, byte byCmd, uint unReg)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		// ԍ0`11ȊO̎̓G[
		if((usAxis < X1_AX) || (usAxis < X1_AX))	return (ILLEGAL_PRM);

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_wReg(hDevID, usAxis, byCmd, unReg);
		}
		return (unRet);
	}

	/// <summary>
	/// o̓obt@Ǐo
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unReg">o̓obt@ǂݏoꂽf[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_rBufDW(uint hDevID, ushort usAxis, ref uint unReg)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		// ԍ0`11ȊO̎̓G[
		if((usAxis < X1_AX) || (usAxis < X1_AX))	return (ILLEGAL_PRM);

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_rBufDW(hDevID, usAxis, ref unReg);
		}
		return (unRet);
	}

	/// <summary>
	/// o̓obt@
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unReg">o̓obt@֏ރf[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_wBufDW(uint hDevID, ushort usAxis, uint unReg)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		// ԍ0`11ȊO̎̓G[
		if((usAxis < X1_AX) || (usAxis < X1_AX))	return (ILLEGAL_PRM);

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_wBufDW(hDevID, usAxis, unReg);
		}
		return (unRet);
	}

	/// <summary>
	/// IvV|[gǏo(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">ǂݏoR}h</param>
	/// <param name="byData">IvV|[gǂݏoꂽf[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_rPortB(uint hDevID, byte byCmd, ref byte byData)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_rPortB(hDevID, byCmd, ref byData);
		}
		return (unRet);
	}

	/// <summary>
	/// IvV|[gǏo([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">ǂݏoR}h</param>
	/// <param name="usData">IvV|[gǂݏoꂽf[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_rPortW(uint hDevID, byte byCmd, ref ushort usData)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_rPortW(hDevID, byCmd, ref usData);
		}
		return (unRet);
	}
    
	/// <summary>
	/// IvV|[g(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">݃R}h</param>
	/// <param name="byData">IvV|[g֏ރf[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_wPortB(uint hDevID, byte byCmd, byte byData)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_wPortB(hDevID, byCmd, byData);
		}
		return (unRet);
	}

	/// <summary>
	/// IvV|[g([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">݃R}h</param>
	/// <param name="usData">IvV|[g֏ރf[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	public static uint hcp52c_wPortW(uint hDevID, byte byCmd, ushort usData)
	{
		System.Object lockThis = new System.Object();

		uint unRet = 0;

		lock (lockThis)
		{
			unRet = Hicpd52c.cp52c_wPortW(hDevID, byCmd, usData);
		}
		return (unRet);
	}

	/// <summary>
	/// {[hCfoCX̎擾
	/// </summary>
	/// <param name="unCnt">{[h̊i[</param>
	/// <param name="hpcInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_GetDevInfo(ref uint unCnt, [In, Out, MarshalAs(UnmanagedType.LPArray)] Hicpd52c.HCP52CINFO[] hpcInfo)
    {
        uint cnt = 0,
            i,
            unRet = 0;

        Hicpd52c.HCP52CINFO[] h = new Hicpd52c.HCP52CINFO[16];

		try
		{
			unRet = Hicpd52c.cp52c_GetDeviceCount(ref cnt);				// {[h擾
			if (unRet != 0)            return (unRet);

			// {[h0܂16ȏ̎̓G[
			if ((0 == cnt) || (16 <= cnt))
			{
				return (ILLEGAL_PRM);
			}

			unCnt = cnt;
            unRet = Hicpd52c.cp52c_GetDeviceInfo(ref cnt, h);	// foCX擾
			if (unRet != 0)            return (unRet);

			for (i = 0; i < cnt; i++)
			{
				hpcInfo[i] = h[i];
			}
		}
		catch(Exception e)
		{
			System.Windows.Forms.MessageBox.Show(e.Message.ToString());
			return 1;
		}

        return (unRet);
    }

	/// <summary>
	/// foCX̃I[vCfoCX̏
	/// </summary>
	/// <param name="hDevID">foCXnh̊i[</param>
	/// <param name="hInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_DevOpen(ref uint hDevID, ref Hicpd52c.HCP52CINFO hInfo)
    {
        uint h = ILLEGAL_HANDLE,
                unRet = 0;
        ushort usAx = 0;
		uint i = 0;

        unRet = Hicpd52c.cp52c_OpenDevice(ref h, ref hInfo);
        if (unRet != 0)
        {
            return (unRet);
        }
        else
        {
            hDevID = h;
 			i = h & 0x0000000f;
			Cp52cl1a.g_elspol[i] = 0;
       }
		
		// IvV|[gݒ
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_ELS_PRT, 0);	// ELSɐI|[g(B)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_CP4_PRT, 0);	// Rp[^4o͐ؑփ|[g(o͕s)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_CP5_PRT, 0);	// Rp[^5o͐ؑփ|[g(o͕s)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_X1C_PRT, 0);	// X1-U1CMPo͐ؑփ|[g(CMP3o)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_X2C_PRT, 0);	// X2-U3CMPo͐ؑփ|[g(CMP3o)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_INT_PRT, 0);	// Cl[u|[g(o͕s)
		unRet |= Hicpd52c.cp52c_wPortW(h, CP52C_FIL_PRT, 0);	// GR[_tB^|[g

		// WX^
		unRet |= Hicpd52c.cp52c_wCmdW( h, X1_AX, SRST );		// X1-U1\tgEFAZbg
		unRet |= Hicpd52c.cp52c_wCmdW( h, X2_AX, SRST );		// X2-U2\tgEFAZbg
		unRet |= Hicpd52c.cp52c_wCmdW( h, X3_AX, SRST );		// X3-U3\tgEFAZbg

		for(usAx = X1_AX; usAx < M_AX; usAx++) 
		{
			// WX^(x[XxWX^:PRFL = 200)
			unRet |= hcp52c_wReg (hDevID, usAx, WPRFL, 200);

			// WX^(쑬xWX^:PRFH = 2000)
			unRet |= hcp52c_wReg (hDevID, usAx, WPRFH, 2000);

			// WX^([gWX^)
			// 		NbNg = 19,660,800Hz,  =  = 0.5b
			// 		PRFH = 2000, PRFL = 200, PRUR:[g
			// 		(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
			// 		PRUR = 1364
			unRet |= hcp52c_wReg (hDevID, usAx, WPRUR, 1364);

			// WX^({ = 1{, PRMG = 299)
			unRet |= hcp52c_wReg (hDevID, usAx, WPRMG, 299);

			// WX^(샂[h:PRMD = 0x8008000)
			unRet |= hcp52c_wReg (hDevID, usAx, WPRMD, 0x8008000);

			// WX^(ړʕ␳x:RFA = 200)
			unRet |= hcp52c_wReg (hDevID, usAx, WRFA, 200);

			// WX^(ݒ1:RENV1 = 0x20434004)
			// 		wߏo:ʃpXw߂̐_
			// 		OLS & DLS & SVALM = B, INPOS = A, 
			// 		ELS & SVALM͎~,DLSo = ̂,ׯȂ,
			// 		޴װ_Aرo͂Ȃ
			unRet |= hcp52c_wReg (hDevID, usAx, WRENV1, 0x20434004);

			// 	ėpo͐ݒ蓙
			// WX^(ݒ2:RENV2 = 0x0020fd55)
			unRet |= hcp52c_wReg(hDevID, usAx, WRENV2, 0x0020fd55);

			// WX^(ݒ3:RENV3 = 0x00f00002)
			// 		_AFݻ+ݺތ_A(OLS+Z), 
			// 		CLROFFON & _Aر 
			unRet |= hcp52c_wReg (hDevID, usAx, WRENV3, 0x00f00002);

			// WX^(CxgINTݒ:RIRQ = 1(~)
			unRet |= hcp52c_wReg (hDevID, usAx, WRIRQ, 1);
		}
		// ~
		unRet |= Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (STOP | 0x0f00));
		unRet |= Hicpd52c.cp52c_wCmdW(hDevID, X2_AX, (STOP | 0x0f00));
		unRet |= Hicpd52c.cp52c_wCmdW(hDevID, X3_AX, (STOP | 0x0f00));

        return (unRet);
    }

	/// <summary>
	/// foCX̃N[Y
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_DevClose(uint hDevID)
    {
        uint unRet = 0;

        unRet = Hicpd52c.cp52c_CloseDevice(hDevID);
        return (unRet);
    }

	/// <summary>
	/// _A̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usMode">_A[h</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetOrgMode(uint hDevID, ushort usAxis, ushort usMode)
    {
        uint unRet = 0;
        uint unRenv3 = 0;
        const uint CTR2_SRC = 0x00000300;
        const uint ORG_MODE = 0x0000000F;

        // ԍ0`11ȊO܂ 
        // _A[h0`12ȊO͈̎G[ 
        if ((usAxis < X1_AX) || (U3_AX < usAxis) || 
            (usMode < 0) || (12 < usMode))
        {
            return (ILLEGAL_PRM);
        }

        // WX^3(RENV3)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV3, ref unRenv3);
		if (unRet != 0)            return (unRet);

        // Orgmode9̎CCTR2͂w߈ʒuɂ 
        // (Orgmode9ȊO̎CCTR2͂͋@Bʒu) 
        if (usMode == 9)
        {
            unRenv3 &= (~CTR2_SRC);
            unRenv3 |= 0x00000100;
        }
        unRenv3 &= (~ORG_MODE);
        unRenv3 |= usMode;

        // WX^3(RENV3) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV3, unRenv3);
        return (unRet);
    }

	/// <summary>
	/// \tg~bg̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="nPsl">+SLS</param>
	/// <param name="nMsl">-SLS</param>
	/// <param name="usEnable">SLSgp/sgp</param>
	/// <param name="usStp">~@</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetSls(uint hDevID, ushort usAxis, int nPsl, int nMsl, ushort usEnable, ushort usStp)
    {
        uint unRet = 0;
        uint unRenv4 = 0;

        // ԍ0`11ȊO 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
        // \tg~bggp+SLS < -SLS͈̎G[ 
		if ((usEnable != 0) && (nPsl <= nMsl))	return (ILLEGAL_PRM);

        // WX^4(RENV4)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV4, ref unRenv4);
        if (unRet != 0)            return (unRet);

		switch (usEnable)
		{
			case 0:
				// SLSsgp 
				unRenv4 &= 0xffffe3e3;
				break;
			case 1:
				// SLSgp 
				unRenv4 &= 0xffff0000;
				if (usStp == 0)			unRenv4 |= 0x00003838;		// ~
				else if (usStp == 1)	unRenv4 |= 0x00005858;		// ~
				else					return (ILLEGAL_PRM);
				break;
			default:
				return (ILLEGAL_PRM);
		}

        // +SLSf[^ݒ(RCMP1)  
        unRet = hcp52c_wReg(hDevID, usAxis, WRCMP1, (uint)nPsl);
		if (unRet != 0)            return (unRet);

        // -SLSf[^ݒ(RCMP2) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRCMP2, (uint)nMsl);
		if (unRet != 0)            return (unRet);

		// WX^4(RENV4) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV4, unRenv4);
        return (unRet);
    }

	/// <summary>
	/// ELS̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usPol">ɐ</param>
	/// <param name="usStp">~@</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetEls(uint hDevID, ushort usAxis, ushort usPol, ushort usStp)
    {
        ushort usData = 0;
        uint unRet = 0;
        uint unRenv1 = 0;
		uint i = 0;

        // ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))			return (ILLEGAL_PRM);

		i = hDevID & 0x000f;
		usData = g_elspol[i];

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
		if (unRet != 0)										return (unRet);

		switch(usPol)
		{
			case 0:	usData &= (ushort)(~(0x01 << usAxis));	break;	// B
			case 1:	usData |= (ushort) (0x01 << usAxis);	break;	// A
			default:										return (ILLEGAL_PRM);
		}

		switch(usStp)
		{
			case 0: unRenv1 &= (uint)(~R1_ELSM_BIT);		break;	// ~
			case 1: unRenv1 |= (uint)R1_ELSM_BIT;			break;  // ~
			default:										return (ILLEGAL_PRM);
		}		

        // ELSɐ|[g 
        unRet = hcp52c_wPortW(hDevID, CP52C_ELS_PRT, usData);
        if (unRet != 0)										return (unRet);

        // WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
		if( unRet == 0 ) 
		{
			g_elspol[i] = usData;
		}

        return (unRet);
    }

	/// <summary>
	/// OLS̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usPol">ɐ</param>
	/// <returns>0:C0ȊO:ُ</returns>			
    public static uint hcp52c_SetOls(uint hDevID, ushort usAxis, ushort usPol)
    {
        uint unRet = 0;
        uint unRenv1 = 0;

        // ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
		if (unRet != 0)				return (unRet);
		switch(usPol)
		{
			case 0:unRenv1 &= (~R1_OLSL_BIT);	break;	// B
			case 1:unRenv1 |= R1_OLSL_BIT;		break;	// A
            default:							return (ILLEGAL_PRM);
        }

        // WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
        return (unRet);
    }

	/// <summary>
	/// SVALM̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usPol">ɐ</param>
	/// <param name="usStp">~@</param>
	/// <returns>0:C0ȊO:ُ</returns>	
    public static uint hcp52c_SetSvAlm(uint hDevID, ushort usAxis, ushort usPol, ushort usStp)
    {
        uint unRet = 0;
        uint unRenv1 = 0;

        // ԍ0`11ȊO͈̎G[ 
        if ((usAxis < X1_AX) || (U3_AX < usAxis))	return (ILLEGAL_PRM);

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
		if (unRet != 0)				return (unRet);
		switch(usPol)
		{
			case 0:	unRenv1 &= (~R1_ALML_BIT);	break;	// B
			case 1:	unRenv1 |= R1_ALML_BIT;		break;	// A
			default:							return (ILLEGAL_PRM);
		}
		switch(usStp)
		{
			case 0: unRenv1 &= (~R1_ALMM_BIT);	break;	// ~
			case 1: unRenv1 |= R1_ALMM_BIT;		break;  // ~
			default:							return (ILLEGAL_PRM);
		}		
        // WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
        return (unRet);
    }

 	/// <summary>
 	/// INPOS̐ݒ
 	/// </summary>
 	/// <param name="hDevID">foCXnh</param>
 	/// <param name="usAxis">ԍ</param>
 	/// <param name="usEnable">gp/sgp</param>
 	/// <param name="usPol">ɐ</param>
 	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetInpos(uint hDevID, ushort usAxis, ushort usEnable, ushort usPol)
    {
        uint unRet = 0;
        uint unRmd = 0;
        uint unRenv1 = 0;

        // ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // 샂[h(PRMD)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RPRMD, ref unRmd);
		if (unRet != 0)            return (unRet);

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
		if (unRet != 0)            return (unRet);

        // INPOSL/
		switch (usEnable)
		{
			case 0:unRmd &= (~MD_INPE_BIT);	break;		// sgp
			case 1:unRmd |= MD_INPE_BIT;	break;		// gp
			default:						return (ILLEGAL_PRM);
		}

        // INPOS͋ɐ
		switch (usPol)
		{
			case 0:unRenv1 &= (~R1_INPL_BIT);	break;	// B
			case 1:unRenv1 |= R1_INPL_BIT;		break;	// A
			default:							return (ILLEGAL_PRM);
		}

        // 샂[h(PRMD) 
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMD, unRmd);
		if (unRet != 0)            return (unRet);
		// WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
        return (unRet);
    }

	/// <summary>
	/// GR[_Z̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usCnt">_AŎgpZ-1</param>
	/// <param name="usPol">ɐ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetEz(uint hDevID, ushort usAxis, ushort usCnt, ushort usPol)
    {
        uint unRet = 0;
        uint unRenv2 = 0;
        uint unRenv3 = 0;

        // ԍ0`11ȊO͈̎G[ 
        // _AŎgpy񐔂16܂łȂ̂usCnt15܂
        if ((usAxis < X1_AX) || (U3_AX < usAxis) || (15 < usCnt))
        {
            return (ILLEGAL_PRM);
        }

        // WX^2(RENV2)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV2, ref unRenv2);
		if (unRet != 0)            return (unRet);

        // WX^3(RENV3)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV3, ref unRenv3);
		if (unRet != 0)            return (unRet);

        // ɐI 
 		switch (usPol)
		{
			case 0:unRenv2 |= R2_EZL_BIT;		break;	// B
			case 1:unRenv2 &= (~R2_EZL_BIT);	break;	// A
			default:							return (ILLEGAL_PRM);
            
        }

        // _AŎgpy
        unRenv3 = (unRenv3 & (uint)0xffffff0f) | (uint)(usCnt << 4);

        // WX^2(RENV2) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV2, unRenv2);
		if (unRet != 0)            return (unRet);

        // WX^3(RENV3) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV3, unRenv3);
        return (unRet);
    }

	/// <summary>
	/// T[{G[JE^NAo͂̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usUse">gp@</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetSvCtrCl(uint hDevID, ushort usAxis, ushort usUse)
    {
        uint unRet = 0;
        uint unRenv1 = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
        if (unRet != 0) return (unRet);

        unRenv1 &= (~(R1_CLRE_BIT | R1_CLRO_BIT));
        switch (usUse)
        {
            case 0:												break;	// sgp
            case 1:  unRenv1 |= R1_CLRO_BIT;					break;	// _A
            case 2:  unRenv1 |= R1_CLRE_BIT;					break;	// ُ~
            case 3:  unRenv1 |= (R1_CLRE_BIT | R1_CLRO_BIT);	break;  // _Ayшُ~ 
			default: return (ILLEGAL_PRM);    
        }
        // WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
        return (unRet);
    }

	/// <summary>
	/// w߃pX̏o͌`̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usCmdPls">w߃pX̏o͌`(ʃpX/ʃpX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetCmdPulse(uint hDevID, ushort usAxis, ushort usCmdPls)
    {
        uint unRet = 0;
        uint unRenv1 = 0;
        const uint PMD = 0x00000007;

        // ԍ0`11ȊO ܂ 
 		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // WX^P(RENV1)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RRENV1, ref unRenv1);
		if (unRet != 0) return (unRet);

        unRenv1 &= (~PMD);
        switch (usCmdPls)
        {
            case 0: unRenv1 |= (uint)0x04;	break;	//  
            case 1: unRenv1 |= (uint)0x02;	break;	//  
            case 2: unRenv1 |= (uint)0x07;	break;
            case 3: unRenv1 |= (uint)0x00;	break;
			default:						return (ILLEGAL_PRM);
        }

        // WX^P(RENV1) 
        unRet = hcp52c_wReg(hDevID, usAxis, WRENV1, unRenv1);
        return (unRet);
    }

	/// <summary>
	/// `ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usAcc">`(/S)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetAccProfile(uint hDevID, ushort usAxis, ushort usAcc)
    {
        uint unRet = 0;
        uint unRmd = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		
		// 샂[h(PRMD)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RPRMD, ref unRmd);
        if (unRet != 0)			return (unRet);
        
		switch (usAcc)
		{
			case 0:unRmd &= (~MD_ACC_BIT);	break;		// 
			case 1:unRmd |= MD_ACC_BIT;		break;		// S
			default:						return (ILLEGAL_PRM);
		}

        // 샂[h(PRMD)
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMD, unRmd);
        return (unRet);
    }

	/// <summary>
	/// Jn_̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usSdp">Jn_̐ݒ(/}jA)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetAutoDec(uint hDevID, ushort usAxis, ushort usSdp)
    {
        uint unRet = 0;
        uint unRmd = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		
		// 샂[h(PRMD)Ǎ 
        unRet = hcp52c_rReg(hDevID, usAxis, RPRMD, ref unRmd);
		if (unRet != 0)			return (unRet);

		switch(usSdp)
		{
			case 0:unRmd &= (~MD_SDP_BIT);	break;	// 
			case 1:unRmd |= MD_SDP_BIT;		break;	// }jA
			default:						return (ILLEGAL_PRM);
		}

        // 샂[h(PRMD)
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMD, unRmd);
        return (unRet);
    }

	/// <summary>
	/// CXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usSts">CXe[^Xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadMainSts(uint hDevID, ushort usAxis, ref ushort usSts)
    {
        uint unRet = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // CXe[^XǍ
        unRet = Hicpd52c.cp52c_rMstsW(hDevID, usAxis, ref usSts);
        return (unRet);
    }

	/// <summary>
	/// G[Xe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unSts">G[Xe[^Xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadErrorSts(uint hDevID, ushort usAxis, ref uint unSts)
    {
        uint unRet = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		
		// G[Xe[^XǍ
        unRet = hcp52c_rReg(hDevID, usAxis, RREST, ref unSts);
        return (unRet);
    }

	/// <summary>
	/// CxgXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unSts">CxgXe[^Xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadEventSts(uint hDevID, ushort usAxis, ref uint unSts)
    {
        uint unRet = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // CxgXe[^XǍ
        unRet = hcp52c_rReg(hDevID, usAxis, RRIST, ref unSts);
        return (unRet);
    }

	/// <summary>
	/// TuXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usSts">TuXe[^Xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadSubSts(uint hDevID, ushort usAxis, ref ushort usSts)
    {
        uint unRet = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // TuXe[^XǍ
        unRet = Hicpd52c.cp52c_rSstsW(hDevID, usAxis, ref usSts);
        return (unRet);
    }

	/// <summary>
	/// gXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unSts">gXe[^Xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadExSts(uint hDevID, ushort usAxis, ref uint unSts)
    {
        uint unRet = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		
		// gXe[^XǍ
        unRet = hcp52c_rReg(hDevID, usAxis, RRSTS, ref unSts);
        return (unRet);
    }

	/// <summary>
	/// xǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usSpd">xi[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadSpd(uint hDevID, ushort usAxis, ref ushort usSpd)
    {
        uint unRet = 0;
        uint unSpd = 0;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // xǍ
        unRet = hcp52c_rReg(hDevID, usAxis, RRSPD, ref unSpd);
        unSpd &= (uint)0x0000ffff;
        usSpd = (ushort)unSpd;
        return (unRet);
    }

 	/// <summary>
	/// JE^Ǎ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usSelCtr">ǂݍރJE^̎w</param>
	/// <param name="nCtrValue">JE^l̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_ReadCtr(uint hDevID, ushort usAxis, ushort usSelCtr, ref int nCtrValue)
    {
        uint unRet = 0;
        uint unData = 0;
        byte byCmd = RRCTR1;

		// ԍ0`11ȊO͈̎G[ 
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);

        // JE^Ǎ
        switch (usSelCtr)
        {
            case 1: byCmd = RRCTR1; break;
            case 2: byCmd = RRCTR2; break;
            case 3: byCmd = RRCTR3; break;
            case 4: byCmd = RRCTR4; break;
			default:				return (ILLEGAL_PRM);
        }

        unRet = hcp52c_rReg(hDevID, usAxis, byCmd, ref unData);
        nCtrValue = (int)unData;
        return (unRet);
    }

 	/// <summary>
	/// Cxg}XN̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unMask">Cxg}XNf[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetEventMask(uint hDevID, ushort usAxis, uint unMask)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // Cxg}XNf[^ 0`0x0003ffffȊO͈̎G[
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		if ((unMask & 0xfffc0000) != 0)         return (ILLEGAL_PRM);

        // Cxg}XN(RIRQ)WX^̏
        unRet = hcp52c_wReg(hDevID, usAxis, WRIRQ, unMask);
        return (unRet);
    }

	/// <summary>
	/// x[Xx̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRfl">x[XxWX^l</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetFLSpd(uint hDevID, ushort usAxis, uint unRfl)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // xWX^1`0xffffȊO͈̎G[
        if ((usAxis < X1_AX) || (U3_AX < usAxis)||
            (unRfl == 0) || (65535 < unRfl))
        {
            return (ILLEGAL_PRM);
        }

        // PRFL̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRFL, unRfl);
        return (unRet);
    }

	/// <summary>
	/// ⏕x̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRfa">⏕xWX^l</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetAuxSpd(uint hDevID, ushort usAxis, uint unRfa)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // xWX^1`0xffffȊO͈̎G[
        if ((usAxis < X1_AX) || (U3_AX < usAxis)||
            (unRfa == 0) || (65535 < unRfa))
        {
            return (ILLEGAL_PRM);
        }

        // RFȀ
        unRet = hcp52c_wReg(hDevID, usAxis, WRFA, unRfa);
        return (unRet);
    }

	/// <summary>
	/// [g̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRur">[gWX^l
	/// NbNg = 19660800Hz
	/// (b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
	/// r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800
	/// </param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetAccRate(uint hDevID, ushort usAxis, uint unRur)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // [g1`0xffffȊO͈̎G[
        if ((usAxis < X1_AX) || (U3_AX < usAxis)||
            (unRur == 0) || (65535 < unRur))
        {
            return (ILLEGAL_PRM);
        }

        // PRUȐ
        unRet = hcp52c_wReg(hDevID, usAxis, WPRUR, unRur);
        return (unRet);
    }

	/// <summary>
	/// [g̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRdr">[gWX^l</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetDecRate(uint hDevID, ushort usAxis, uint unRdr)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // [g1`0xffffȊO͈̎G[
        if ((usAxis < X1_AX) || (U3_AX < usAxis)|| (65535 < unRdr))
        {
            return (ILLEGAL_PRM);
        }

        // PRDȐ
        unRet = hcp52c_wReg(hDevID, usAxis, WPRDR, unRdr);
        return (unRet);
    }

	/// <summary>
	/// x{WX^̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRmg">x{WX^l(RMG) RMG=300/x{-1 </param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetMult(uint hDevID, ushort usAxis, uint unRmg)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // {ݒl2`4095ȊO͈G[ 
        if ((usAxis < X1_AX) || (U3_AX < usAxis) || (unRmg < 2) || (4095 < unRmg)) 
        {
            return (ILLEGAL_PRM);
        }

        // PRMG̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMG, unRmg);
        return (unRet);
    }

	/// <summary>
	/// Jn_̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="nRdp">Jn_</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SetDecPoint(uint hDevID, ushort usAxis, int nRdp)
    {
        uint unRet = 0;
        uint unData = (uint)nRdp;

        // ԍ0`11ȊO̓G[
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		
        // PRDP̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRDP, unData);
        return (unRet);
    }

	/// <summary>
	/// 샂[h
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="usMode">샂[h</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritOpeMode(uint hDevID, ushort usAxis, ushort usMode)
    {
        uint unRet = 0;
        uint unRmd = 0;

        // ԍ0`11ȊO܂
        // 샂[hُ͈̎G[
		if ((usAxis < X1_AX) || (U3_AX < usAxis))		return (ILLEGAL_PRM);
		if ((usMode & 0xff80) != 0)             return (ILLEGAL_PRM);

        // 샂[h(PRMD)Ǎ
        unRet = hcp52c_rReg(hDevID, usAxis, RPRMD, ref unRmd);
		if (unRet != 0)            return (unRet);

        unRmd &= 0xef3a700;
        if (usMode == 0x42)	unRmd |= 0x4041;
		else				unRmd |= usMode;

        // 샂[h(PRMD)
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMD, unRmd);
        return (unRet);
    }

	/// <summary>
	/// 쑬xWX^̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="unRfh">쑬xWX^l</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritFHSpd(uint hDevID, ushort usAxis, uint unRfh)
    {
        uint unRet = 0;

        // ԍ0`11ȊO܂
        // xWX^1`0xffffȊO͈̎G[
        if ((usAxis < X1_AX) || (U3_AX < usAxis) ||
            (unRfh == 0) || (65535 < unRfh))
        {
            return (ILLEGAL_PRM);
        }

        // PRFH̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRFH, unRfh);
        return (unRet);
    }

	/// <summary>
	/// ʒu߈ړʂ̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="nDstnc">ړ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritPos(uint hDevID, ushort usAxis, int nDstnc)
    {
        uint unRet;				// ߂l
        uint unData=(uint)nDstnc;

        // ԍ0`11ȊO̓G[
        // ړʂ̃`FbN
        if ((usAxis < X1_AX) || (U3_AX < usAxis) ||
            (nDstnc < -134217728) || (134217727 < nDstnc)) 
        {
            return (ILLEGAL_PRM);
        }

        // PRMV̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMV, unData);
        return (unRet);
    }

	/// <summary>
	/// Ԃ̈ړʂ̐ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="nDstnc">ړ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritLine(uint hDevID, ushort usAxis, int nDstnc)
    {
        uint unRet = 0;
        uint unData = (uint)nDstnc;

        // ԍ0`11ȊO̓G[
        // ړʂ̃`FbN
        if ((usAxis < X1_AX) || (U3_AX < usAxis) ||
            (nDstnc < -134217728) || (134217727 < nDstnc))
        {
            return (ILLEGAL_PRM);
        }

        // PRMV̏
        unRet = hcp52c_wReg(hDevID, usAxis, WPRMV, unData);
        return (unRet);
    }

 	/// <summary>
	/// ~ʕԂ̃f[^ݒ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹</param>
	/// <param name="nEnd1">I_ʒu1</param>
	/// <param name="nEnd2">I_ʒu2</param>
	/// <param name="nCen1">Sʒu1</param>
	/// <param name="nCen2">Sʒu2</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritCircl(uint hDevID, ushort usAxis,
                            int nEnd1, int nEnd2, int nCen1, int nCen2)
    {
        uint unRet = 0;
        ushort usAx1 = 0;
        ushort usAx2 = 0;
        uint unEnd1 = (uint)nEnd1;
        uint unEnd2 = (uint)nEnd2;
        uint unCen1 = (uint)nCen1;
        uint unCen2 = (uint)nCen2;

        // Ԏ̑gݍ킹̈0`17ȊO̎̓G[
        // SʒuƏI_ʒũ`FbN
        if ((usAxis < 0) || (17 < usAxis) ||  
        (nEnd1 < -134217728) || (134217727 < nEnd1)|| 
        (nEnd2 < -134217728) || (134217727 < nEnd2)||  
        (nCen1 < -134217728) || (134217727 < nCen1)||
        (nCen2 < -134217728) || (134217727 < nCen2))
        {
            return (ILLEGAL_PRM);
        }
        if ((nCen1 == 0) && (nCen2 == 0))
        {
            return (ILLEGAL_PRM);
        }

		switch(usAxis) 
		{
			case  0:	usAx1 = 0;	usAx2 = 1;	break;	// X1(0),  Y1(1)
			case  1:	usAx1 = 0;	usAx2 = 2;	break;	// X1(0),  Z1(2)
			case  2:	usAx1 = 0;	usAx2 = 3;	break;	// X1(0),  U1(3)
			case  3:	usAx1 = 1;	usAx2 = 2;	break;	// Y1(1),  Z1(2)
			case  4:	usAx1 = 1;	usAx2 = 3;	break;	// Y1(1),  U1(3)
			case  5:	usAx1 = 2;	usAx2 = 3;	break;	// Z1(2),  U1(3)
			case  6:	usAx1 = 4;	usAx2 = 5;	break;	// X2(4),  Y2(5)
			case  7:	usAx1 = 4;	usAx2 = 6;	break;	// X2(4),  Z2(6)
			case  8:	usAx1 = 4;	usAx2 = 7;	break;	// X2(4).  U2(7)
			case  9:	usAx1 = 5;	usAx2 = 6;	break;	// Y2(5),  Z2(6)
			case 10:	usAx1 = 5;	usAx2 = 7;	break;	// Y2(5),  U2(7)
			case 11:	usAx1 = 6;	usAx2 = 7;	break;	// Z2(6),  U2(7)
			case 12:	usAx1 = 8;	usAx2 = 9;	break;	// X3(8),  Y3(9)
			case 13:	usAx1 = 8;	usAx2 =10;	break;	// X3(8),  Z3(10)
			case 14:	usAx1 = 8;	usAx2 =11;	break;	// X3(8).  U3(11)
			case 15:	usAx1 = 9;	usAx2 =10;	break;	// Y3(9),  Z3(10)
			case 16:	usAx1 = 9;	usAx2 =11;	break;	// Y3(9),  U3(11)
			case 17:	usAx1 =10;	usAx2 =11;	break;	// Z3(10), U3(11)
		}

        // PRMV(I_ʒu)̏
        unRet = hcp52c_wReg(hDevID, usAx1, WPRMV, unEnd1);
        if (unRet != 0)            return (unRet);
        unRet = hcp52c_wReg(hDevID, usAx2, WPRMV, unEnd2);
		if (unRet != 0)            return (unRet);

        // PRIP(Sʒu)̏
        unRet = hcp52c_wReg(hDevID, usAx1, WPRIP, unCen1);
		if (unRet != 0)            return (unRet);
		unRet = hcp52c_wReg(hDevID, usAx2, WPRIP, unCen2);
        return (unRet);
    }

	/// <summary>
	/// JE^vZbg
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <param name="nData">vZbgl</param>
	/// <param name="usCtr">JE^I</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_WritCtr(uint hDevID, ushort usAxis, int nData, ushort usCtr)
    {
        byte byCmd = WRCTR1;
        uint unRet = 0;
        uint unData = (uint)nData;

        // ԍ0`11ȊO̎̓G[
		if((usAxis < X1_AX) || (usAxis < X1_AX))	return (ILLEGAL_PRM);

        // vZbgl̃`FbN
        if (usCtr == 3)
        {	
            // JE^R͂PUrbg
            if ((nData < -32768) || (32767 < nData))
            {
                return (ILLEGAL_PRM);
            }
        }
        else
        {	
            // ̑̃JE^͂RQrbg
            if ((nData < -134217728) || (134217727 < nData))
            {
                return (ILLEGAL_PRM);
            }
        }

        // vZbgl
		switch(usCtr)
		{
			case 1:	byCmd = WRCTR1;	break;
			case 2:	byCmd = WRCTR2;	break;
			case 3:	byCmd = WRCTR3;	break;
			case 4:	byCmd = WRCTR4;	break;
			default:				return (ILLEGAL_PRM);
		}			

		unRet = hcp52c_wReg(hDevID, usAxis, byCmd, unData);
        return (unRet);
    }

	/// <summary>
	/// Xgbv(֐)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <param name="usCmd">XgbvR}h</param>
	/// <returns>0:C0ȊO:ُ</returns>
	private static uint cpd_Stop(uint hDevID, ushort usAxis, ushort usCmd)
	{
		uint unRet = 0;
		
		// ԍ0x01`0x0fffȊO̎̓G[
		if((usAxis <= 0) || (0x0fff < usAxis))	return (ILLEGAL_PRM);

		if(0!=(usAxis & 0x000f)) 
		{			
			// X1-U1
			usCmd = (ushort)((usAxis << 8) | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, usCmd);	// X1R}h
		} 
		if((0!=(usAxis & 0x00f0)) && (unRet == 0)) 
		{	
			// X2-U2
			usCmd = (ushort)((usAxis << 4) | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X2_AX, usCmd);	// X2R}h
		} 
		if((0!=(usAxis & 0x0f00)) && (unRet == 0)) 
		{	
			// X3-U3
			usCmd = (ushort)(usAxis | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X3_AX, usCmd);	// X3R}h
		} 
		return (unRet);
	}


	/// <summary>
	/// ~
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_DecStop(uint hDevID, ushort usAxis)
    {
		return cpd_Stop(hDevID, usAxis, SDSTP);
    }

    // ~
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_QuickStop(uint hDevID, ushort usAxis)
    {
		return cpd_Stop(hDevID, usAxis, STOP);
    }

    // ~ 
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_EmgStop(uint hDevID, ushort usAxis)
    {
		return cpd_Stop(hDevID, usAxis, CMEMG);
    }

    // ~
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SyDecStop(uint hDevID, ushort usAxis)
    {
		ushort usAx = 0;
		uint[] unRmd = {0,0,0,0,0,0,0,0,0,0,0,0};
		uint unRenv1 = 0;
		uint unData = 0;
		uint unRet = 0;
		ushort[] usAxBit = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

		// ԍ0x01`0x0fffȊO̎̓G[
		if ((usAxis <= 0) || (0x0fff < usAxis))	return (ILLEGAL_PRM);
        
		for(usAx=X1_AX; usAx < usAxBit.Length; usAx++) 
		{
            if ((usAxis & usAxBit[usAx])==usAxBit[usAx])
            {
				// wߎ
		        // WX^P(RENV1): ~
                unRet = hcp52c_rReg(hDevID, usAx, RRENV1, ref unRenv1);
				if (unRet != 0)            return (unRet);
				// STP͎~ݒ̏ꍇ
				if ((unRmd[usAx] & R1_CSTP_BIT) == 0)
                {
                    unRenv1 |= (uint)R1_CSTP_BIT;	// STP͂Ō~
                    unRet = hcp52c_wReg(hDevID, usAx, WRENV1, unRenv1);
					if (unRet != 0)            return (unRet);
				}
                
                // 샂[h(RMD): STP͗L
                unRet = hcp52c_rReg(hDevID, usAx, RRMD, ref unRmd[usAx]);
				if (unRet != 0)            return (unRet);
				// STP͖ȂSTP͗L
				if ((unRmd[usAx] & MD_STPE_BIT) == 0)
                {
                    unData = unRmd[usAx] | MD_STPE_BIT;
                    unRet = hcp52c_wReg(hDevID, usAx, WRMD, unData);
					if (unRet != 0)            return (unRet);
				}
            }
            else
            {
				// wߎ
				// 샂[h(RMD) 
				unRet = hcp52c_rReg(hDevID, usAx, RRMD, ref unRmd[usAx]);
				if (unRet != 0)            return (unRet);
				// STP͗LȂSTP͗L
				if ((unRmd[usAx] & MD_STPE_BIT) == MD_STPE_BIT)
				{
					unData = unRmd[usAx] & (~MD_STPE_BIT);
					unRet = hcp52c_wReg(hDevID, usAx, WRMD, unData);
					if (unRet != 0)            return (unRet);
				}
			}
        }
        unRet = Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, CMSTP);	// XFSTPo
		if (unRet != 0)            return (unRet);

		// 샂[h߂
		for (usAx = X1_AX; usAx < usAxBit.Length; usAx++)
		{
			if ((usAxis & usAxBit[usAx]) == usAxBit[usAx])
			{
				unData = unRmd[usAx] & (~MD_STPE_BIT);
				unRet = hcp52c_wReg(hDevID, usAx, WRMD, unData);
				if (unRet != 0)            return (unRet);
			}
			else
			{
				unRet = hcp52c_wReg(hDevID, usAx, WRMD, unRmd[usAx]);
				if (unRet != 0)            return (unRet);
			}
		}
        return (unRet);
    }

    // ~ 
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SyQuickStop(uint hDevID, ushort usAxis)
    {
		ushort i = 0;
		uint[] unRmd = {0,0,0,0,0,0,0,0,0,0,0,0};
		uint unRenv1 = 0;
		uint unData = 0;
		uint unRet = 0;
		ushort[] usAxBit = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

		// ԍ0x01`0x0fffȊO̎̓G[
		if ((usAxis <= 0) || (0x0fff < usAxis))	return (ILLEGAL_PRM);

		for(i=X1_AX; i < usAxBit.Length; i++) 
		{
			if ((usAxis & usAxBit[i])==usAxBit[i])
			{
				// wߎ
				// WX^P(RENV1): ~
				unRet = hcp52c_rReg(hDevID, i, RRENV1, ref unRenv1);
				if (unRet != 0)            return (unRet);
				// STP͎~ݒ̏ꍇ
				if ((unRmd[i] & R1_CSTP_BIT) == R1_CSTP_BIT)
				{
					unRenv1 &= (uint)(~R1_CSTP_BIT);	// STP͂ő~
					unRet = hcp52c_wReg(hDevID, i, WRENV1, unRenv1);
					if (unRet != 0)            return (unRet);
				}
                
				// 샂[h(RMD): STP͗L
				unRet = hcp52c_rReg(hDevID, i, RRMD, ref unRmd[i]);
				if (unRet != 0)            return (unRet);
				// STP͖ȂSTP͗L
				if ((unRmd[i] & MD_STPE_BIT) == 0)
				{
					unData = unRmd[i] | MD_STPE_BIT;
					unRet = hcp52c_wReg(hDevID, i, WRMD, unData);
					if (unRet != 0)            return (unRet);
				}
			}
			else
			{
				// wߎ
				// 샂[h(RMD) 
				unRet = hcp52c_rReg(hDevID, i, RRMD, ref unRmd[i]);
				if (unRet != 0)            return (unRet);
				// STP͗LȂSTP͗L
				if ((unRmd[i] & MD_STPE_BIT) == MD_STPE_BIT)
				{
					unData = unRmd[i] & (~MD_STPE_BIT);
					unRet = hcp52c_wReg(hDevID, i, WRMD, unData);
					if (unRet != 0)            return (unRet);
				}
			}
		}
		unRet = Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, CMSTP);	// XFSTPo
		if (unRet != 0)            return (unRet);

		// 샂[h߂
		for (i = X1_AX; i < usAxBit.Length; i++)
		{
			if ((usAxis & usAxBit[i]) == usAxBit[i])
			{
				unData = unRmd[i] & (~MD_STPE_BIT);
				unRet = hcp52c_wReg(hDevID, i, WRMD, unData);
				if (unRet != 0)            return (unRet);
			}
			else
			{
				unRet = hcp52c_wReg(hDevID, i, WRMD, unRmd[i]);
				if (unRet != 0)            return (unRet);
			}
		}
		return (unRet);
    }

	/// <summary>
	/// X^[g(֐)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <param name="usCmd">X^[gR}h</param>
	/// <returns>0:C0ȊO:ُ</returns>
	private static uint cpd_Start(uint hDevID, ushort usAxis, ushort usCmd)
	{
        ushort i = 0;
		uint unData = 0;
		uint[] unRmd = {0,0,0,0,0,0,0,0,0,0,0,0};
        uint unRet = 0;
        ushort[] usAxBit = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

		// ԍ0x01`0x0fffȊO̎̓G[
		if((usAxis <= 0) || (0x0fff < usAxis))	return (ILLEGAL_PRM);

		if(0==(usAxis & 0x0ff0)) 
		{			
			// X1-U1̂
			usCmd = (ushort)((usAxis << 8) | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, usCmd);	// X1R}h
		} 
		else if(0==(usAxis & 0x0f0f)) 
		{	
			// X2-U2̂
			usCmd = (ushort)((usAxis << 4) | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X2_AX, usCmd);	// X2R}h
		} 
		else if(0==(usAxis & 0x00ff)) 
		{	
			// X3-U3̂
			usCmd = (ushort)(usAxis | usCmd);
			unRet = Hicpd52c.cp52c_wCmdW(hDevID, X3_AX, usCmd);	// X3R}h
		} 
		else 
		{	
			// X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ
			for (i = 0; i < usAxBit.Length; i++)
            {
			    if((usAxis & usAxBit[i]) == usAxBit[i]){
			    // X^[g:wߎ
				    // 샂[h(RMD): X^[g
                    unRet = hcp52c_rReg(hDevID, i, RPRMD, ref unRmd[i]);
					if (unRet != 0)            return (unRet);
					unData = unRmd[i] & (~(MD_MSY0_BIT | MD_MSY1_BIT));
                    unData |= MD_MSY0_BIT;
                    unRet = hcp52c_wReg(hDevID, i, WRMD, unData);
					if (unRet != 0)            return (unRet);
					unRet = Hicpd52c.cp52c_wCmdW(hDevID, i, usCmd);	// R}h
					if (unRet != 0)            return (unRet);
				} 
				else 
				{
			    // X^[g:wߎ
				    // 샂[h(RMD): STA͂ŃX^[gȂ
                    unRet = hcp52c_rReg(hDevID, i, RPRMD, ref unRmd[i]);
					if (unRet != 0)            return (unRet);
					unData = unRmd[i] & (~(MD_MSY0_BIT | MD_MSY1_BIT));
                    unRet = hcp52c_wReg(hDevID, i, WRMD, unData);
					if (unRet != 0)            return (unRet);
				}
		    }
		    unRet = Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, CMSTA);			// X1X^[go
            for (i = 0; i < usAxBit.Length; i++)
            {
			    if(((usAxis & usAxBit[i]) == usAxBit[i])) {
				    // 샂[h(RMD)
                    unRet = hcp52c_wReg(hDevID, i, WRMD, unRmd[i]);
					if (unRet != 0)            return (unRet);
				}
		    }
        }
        return (unRet);
	}

	/// <summary>
	/// X^[g
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_AccStart(uint hDevID, ushort usAxis)
    {
		return cpd_Start(hDevID, usAxis, STAUD);
    }

	/// <summary>
	/// FH葬X^[g
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_CnstStartFH(uint hDevID, ushort usAxis)
    {
		return cpd_Start(hDevID, usAxis, STAFH);
    }

	/// <summary>
	/// FL葬X^[g 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_CnstStartFL(uint hDevID, ushort usAxis)
    {
		return cpd_Start(hDevID, usAxis, STAFL);
    }

	/// <summary>
	/// FH葬X^[g㌸~
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_CnstStartByDec(uint hDevID, ushort usAxis)
    {
		return cpd_Start(hDevID, usAxis, STAFHD);
    }

    // T[{I
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SvOn(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVON;

		// ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
		return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

    // T[{It
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SvOff(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVOFF;
		
		// ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
		return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

    // T[{ZbgI
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SvResetOn(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVRSTON;
		
		// ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
		return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

    // T[{ZbgIt 
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_SvResetOff(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVRSTOFF;
		
		// ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
		return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

    // pX[^I
    // 		FfoCXnhCgݍ킹(HEX)
	/// <summary>
	/// 
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">ԍ</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_PMOn(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVOFF;

        // ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
        return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

	/// <summary>
	/// pX[^It
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis">gݍ킹(HEX)</param>
	/// <returns>0:C0ȊO:ُ</returns>
    public static uint hcp52c_PMOff(uint hDevID, ushort usAxis)
    {
        ushort usCmd = SVON;

		// ԍ0x01`0xfȊO̎̓G[
		if ((usAxis <= 0) || (0xf < usAxis))	return (ILLEGAL_PRM);
		return Hicpd52c.cp52c_wCmdW(hDevID, X1_AX, (ushort)(((usAxis & 0x0f) << 8) | usCmd));
    }

	/// <summary>
	/// [ǧvZ
	/// </summary>
	/// <param name="unRate">()[gWX^lvZ</param>
	/// <param name="unTime">()(msec)</param>
	/// <param name="unRfh">쑬xWX^l</param>
	/// <param name="unRfl">x[XxWX^l</param>
	/// <param name="usAcc">`</param>
	/// <param name="usS">\</param>
	/// <returns>0:C0ȊO:ُ</returns>
		
    public static uint hcp52c_CalAccRate(ref uint unRate, uint unTime, 
										uint unRfh, uint unRfl, 
										ushort usAcc, ushort usS)
    {
        double dblData = 0;
        double dblTime = 0;
        uint unData = 0;

        if ((unRfl == 0) || (unRfh == 0) || (unRfh <= unRfl) || (unTime == 0)) 
        {
            return (ILLEGAL_PRM);
        }

        dblTime = (double)unTime / 1000;    // (b)

		if (usS == 0)
		{
			if (usAcc==0)
			{
				// [g:PRUR = 4915200 * ( / (FH - FL)) - 1)
				dblData = dblTime / (unRfh - unRfl);
				dblData = 4915200 * dblData - 1;
			}
			else if (usAcc == 1)
			{
				// ̂Ȃr[g:PRUR = 2457600 * ( / (FH - FL)) - 1)
				dblData = dblTime / (unRfh - unRfl);
				dblData = 2457600 * dblData - 1;
			}
			else
			{
				return (ILLEGAL_PRM);
			}
		}
		else if(usS<32767)
		{
			dblData = dblTime / (unRfh - unRfl + 2 * usS);
			dblData = 4915200 * dblData - 1;
		}
		else
		{
			return (ILLEGAL_PRM);	
		}

		unData = (uint)dblData;
		if ((unData == 0) || (65535 < unData)) 
		{
			return (ILLEGAL_PRM);
		} 
		else 
		{
			unRate = unData;
			return (0);
		}
    }
}