
using System;
using System.Runtime.InteropServices;

/// <summary>
///  PCI CPD Series Devise Driver I/F DLL for Windows	
///		file name:Hicpd52c.cs			
///      date     :2009/12/15			
///      version  :1.0.0.0 VK쐬	
///	Copyright(C) 2009 Hivertec,inc. All Rights Reserved.	
/// </summary>
public class Hicpd52c
{
	/// </summary>


    [StructLayout(LayoutKind.Sequential)]
    public struct HCP52CINFO
    {
        /// <summary>
        /// oXԍ
        /// </summary>
		public uint dwBusNumber;
		
		/// <summary>
		/// foCXԍ
		/// </summary>
        public uint dwDeviceNumber;
 
		/// <summary>
		/// x[XAhXQ
		/// </summary>
        public uint dwBaseAddress2;
	
		/// <summary>
		/// x[XAhXR
		/// </summary>
		public uint dwBaseAddress3;

		/// <summary>
		/// x[XAhXS
		/// </summary>
		public uint dwBaseAddress4;

		/// <summary>
		/// IRQԍ
		/// </summary>
        public uint dwIrqNo;
        
		/// <summary>
		/// Ǘԍ(Windows 9xł͖)
		/// </summary>
		public uint dwNumber;
        
		/// <summary>
		/// {[hID
		/// </summary>
		public uint dwBoardID;
    }

	/// <summary>
	/// foCX̎擾
	/// </summary>
	/// <param name="pDevNum">foCX̌̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_GetDeviceCount(ref uint pDevNum);
    
	/// <summary>
	/// foCX̎擾
	/// </summary>
	/// <param name="pDevNum">foCX̌̊i[</param>
	/// <param name="pHpcDevInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_GetDeviceInfo(ref uint pDevNum, [In, Out, MarshalAs(UnmanagedType.LPArray)] HCP52CINFO[] pHpcDevInfo);
    
	/// <summary>
	/// foCXI[v
	/// </summary>
	/// <param name="hDevID">foCXnhi[</param>
	/// <param name="pHpcDevInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_OpenDevice(ref uint hDevID, ref HCP52CINFO pHpcDevInfo);
    
	/// <summary>
	/// foCXN[Y
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_CloseDevice(uint hDevID);
    
	/// <summary>
	/// CXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rMstsW(uint hDevID, ushort usAxis, ref ushort usData);
    
	/// <summary>
	/// TuXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rSstsW(uint hDevID, ushort usAxis, ref ushort usData);
    
	/// <summary>
	/// R}h
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="usCmd">R}h</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_wCmdW(uint hDevID, ushort usAxis, ushort usCmd);
    
	/// <summary>
	/// WX^Ǎ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="byCmd">WX^ǍR}h</param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rReg(uint hDevID, ushort usAxis, byte byCmd, ref uint unData);
    
	/// <summary>
	/// WX^
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="byCmd">WX^R}h</param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_wReg(uint hDevID, ushort usAxis, byte byCmd, uint unData);
    
	/// <summary>
	/// IvV|[gǏo(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gǏoR}h</param>
	/// <param name="byData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rPortB(uint hDevID, byte byCmd, ref byte byData);
	
	/// <summary>
	/// IvV|[gǏo([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gǏoR}h</param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rPortW(uint hDevID, byte byCmd, ref ushort usData);
    
	/// <summary>
	/// IvV|[g(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gR}h</param>
	/// <param name="byData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_wPortB(uint hDevID, byte byCmd, byte byData);
	
	/// <summary>
	/// IvV|[g([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gR}h</param>
	/// <param name="usData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_wPortW(uint hDevID, byte byCmd, ushort usData);
    
	/// <summary>
	/// o̓obt@Ǐo
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_rBufDW(uint hDevID, ushort usAxis, ref uint unData);
    
	/// <summary>
	/// o̓obt@
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usAxis"></param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("Hicpd52c.dll")]
    public static extern uint cp52c_wBufDW(uint hDevID, ushort usAxis, uint unData);
  }
