'===============================================
'  HPCI-CPD5212M
'  Library lebel1a function for Visual Basic .NET
'      file name:cp52cl1a.vb
'   Copyright(C) 2007-2009
'   Hivertec Inc. All Rights Reserved.
'===============================================
Option Strict Off
Option Explicit On 

Module cp52cl1a
    ' 萔`
    Public Const CP52C_ELS_PRT As Short = &H0S ' ELSɐI|[g
    Public Const CP52C_CP4_PRT As Short = &H2S ' CSTAo͐ؑփ|[g
    Public Const CP52C_CP5_PRT As Short = &H4S ' CSTPo͐ؑփ|[g
    Public Const CP52C_X1C_PRT As Short = &H6S ' CPD5212 X1-U1CMPo͐ؑփ|[g
    Public Const CP52C_X2C_PRT As Short = &H8S ' CPD5212 X2-U3CMPo͐ؑփ|[g
    Public Const CP52C_INT_PRT As Short = &HCS ' o͋|[g'
    Public Const CP52C_FIL_PRT As Short = &H12S ' GR[_tB^ݒ'

    ' ԍ
    Public Const X1_AX As Short = 0
    Public Const Y1_AX As Short = 1
    Public Const Z1_AX As Short = 2
    Public Const U1_AX As Short = 3
    Public Const X2_AX As Short = 4
    Public Const Y2_AX As Short = 5
    Public Const Z2_AX As Short = 6
    Public Const U2_AX As Short = 7
    Public Const X3_AX As Short = 8
    Public Const Y3_AX As Short = 9
    Public Const Z3_AX As Short = 10
    Public Const U3_AX As Short = 11

    Public g_elspol(16) As Short

    ' ----------------------------------------------------------------------------
    ' 샂[hLffe[ui샂[hݒ֐ hcp52c_WritOpeMode() QƁj
    ' R[hF1ȂΗLCOȂΖ
    ' ----------------------------------------------------------------------------
    '0123456789abcdef
    Public Const MOD_TBL As String = "1110000010000000" & "1010010010100100" & "1010100010101000" _
                                   & "0000000000000000" & "0110111100000010" & "0100111000000000" _
                                   & "1111110000000000" & "0000000000000000"

    ' =======================================
    '             foCX֌W̊֐
    ' =======================================
    ' {[hCfoCX̎擾
    ' F{[h̃AhXCfoCX̃AhX
    Public Function hcp52c_GetDevInfo(ByRef pDeviceCount As Integer, ByRef pDeviceInfo() As HCP52CINFO) As Integer
        Dim dwDevCnt As Integer ' cpd52c{[h
        Dim dwRet As Integer ' ߂l

        dwRet = cp52c_GetDeviceCount(dwDevCnt) ' {[h擾
        If (dwRet) Then
            hcp52c_GetDevInfo = dwRet
            Exit Function
        End If

        ' {[h0܂16ȏ̎̓G[
        If ((dwDevCnt = 0) Or (dwDevCnt >= 16)) Then
            hcp52c_GetDevInfo = &H100S
            Exit Function
        End If

        pDeviceCount = dwDevCnt

        dwRet = cp52c_GetDeviceInfo(dwDevCnt, pDeviceInfo) ' foCX擾
        If (dwRet) Then
            hcp52c_GetDevInfo = dwRet
            Exit Function
        End If

        hcp52c_GetDevInfo = 0
    End Function

    ' foCX̃I[vCfoCX̏
    ' FfoCXnh̃AhXCfoCX̃AhX
    Public Function hcp52c_DevOpen(ByRef hDeviceID As Integer, ByRef DevInfo As HCP52CINFO) As Integer
        Dim wAx As Short ' 
        Dim hDevID As Integer ' foCXnh
        Dim dwAns As Integer ' ֐߂l
        Dim dwRet As Integer ' ߂l

        dwRet = cp52c_OpenDevice(hDevID, DevInfo)
        If (dwRet <> 0) Then
            hcp52c_DevOpen = dwRet
            Exit Function
        Else
            hDeviceID = hDevID
        End If
        g_elspol(hDevID And &HFS) = 0

        dwAns = 0

        ' IvV|[gݒ
        dwRet = cp52c_wPortW(hDevID, CP52C_ELS_PRT, 0) ' ELSɐI|[g
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_CP4_PRT, 0) ' CSTAo͐ؑփ|[g
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_CP5_PRT, 0) ' CSTPo͐ؑփ|[g
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_X1C_PRT, 0) ' CPD5212 X1-U1CMPo͐ؑփ|[g
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_X2C_PRT, 0) ' CPD5212 X2-U3CMPo͐ؑփ|[g
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_INT_PRT, 0) ' o͋|[g'
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wPortW(hDevID, CP52C_FIL_PRT, 0) ' GR[_tB^ݒ'
        dwAns = dwAns Or dwRet

        ' WX^
        dwRet = cp52c_wCmdW(hDevID, 0, &H4S) ' X1-U1\tgEFAZbg
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wCmdW(hDevID, 4, &H4S) ' X2-U2\tgEFAZbg
        dwAns = dwAns Or dwRet
        dwRet = cp52c_wCmdW(hDevID, 8, &H4S) ' X2-U2\tgEFAZbg
        dwAns = dwAns Or dwRet

        For wAx = 0 To 11
            ' WX^(x[XxWX^:PRFL = 200)
            dwRet = cp52c_wReg(hDevID, wAx, &H81S, 200)
            dwAns = dwAns Or dwRet

            ' WX^(쑬xWX^:PRFH = 2000)
            dwRet = cp52c_wReg(hDevID, wAx, &H82S, 2000)
            dwAns = dwAns Or dwRet

            ' WX^([gWX^)
            '      NbNg = 19,660,800Hz,  =  = 0.5b
            '      PRFH = 2000, PRFL = 200, PRUR:[g
            '      (b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
            '      PRUR = 1364
            dwRet = cp52c_wReg(hDevID, wAx, &H83S, 1364)
            dwAns = dwAns Or dwRet

            ' WX^({ = 1{, PRMG = 299)
            dwRet = cp52c_wReg(hDevID, wAx, &H85S, 299)
            dwAns = dwAns Or dwRet

            ' WX^(샂[h:PRMD = &h8008000)
            dwRet = cp52c_wReg(hDevID, wAx, &H87S, &H8008000)
            dwAns = dwAns Or dwRet

            ' WX^(ړʕ␳x:RFA = 200)
            dwRet = cp52c_wReg(hDevID, wAx, &H9BS, 200)
            dwAns = dwAns Or dwRet

            ' WX^(ݒ1:RENV1 = &h20434004)
            '      wߏo:ʃpXw߂̐_
            '      OLS & DLS & SVALM = B, INPOS = A,
            '      ELS & SVALM͎~,DLSo = ̂,ׯȂ,
            '      ޴װ_Aرo͂Ȃ
            dwRet = cp52c_wReg(hDevID, wAx, &H9CS, &H20434004)
            dwAns = dwAns Or dwRet

            '  ėpo͐ݒ蓙
            ' WX^(ݒ2:RENV2 = &H0020FD55)
            dwRet = cp52c_wReg(hDevID, wAx, &H9DS, &H20FD55)
            dwAns = dwAns Or dwRet

            ' WX^(ݒ3:RENV3 = &h00f00002)
            '      _AFݻ+ݺތ_A(OLS+Z),
            '      CLROFFON & _Aر
            dwRet = cp52c_wReg(hDevID, wAx, &H9ES, &HF00002)
            dwAns = dwAns Or dwRet

            ' WX^(CxgINTݒ:RIRQ = 1(~)
            dwRet = cp52c_wReg(hDevID, wAx, &HACS, 1)
            dwAns = dwAns Or dwRet

            ' SVON OFF
            dwRet = cp52c_wCmdW(hDevID, wAx, &H10S)
            dwAns = dwAns Or dwRet

            ' SVRST OFF
            dwRet = cp52c_wCmdW(hDevID, wAx, &H11S)
            dwAns = dwAns Or dwRet
        Next wAx

        hcp52c_DevOpen = dwAns
    End Function

    ' foCX̃N[Y
    ' FfoCXnh
    Public Function hcp52c_DevClose(ByVal hDevID As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        dwRet = cp52c_CloseDevice(hDevID) ' foCX̃N[Y

        hcp52c_DevClose = dwRet

    End Function

    ' =======================================
    '            ݒn̊֐
    ' =======================================
    ' _A̐ݒ
    ' FfoCXnhCC_A[h
    Public Function hcp52c_SetOrgMode(ByVal hDevID As Integer, ByVal axis As Short, ByVal mode As Short) As Integer
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer

        ' ԍ0`11ȊO܂
        ' _A[h0`12ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetOrgMode = &H100S
            Exit Function
        End If

        If ((mode < 0) Or (12 < mode)) Then
            hcp52c_SetOrgMode = &H100S
            Exit Function
        End If

        ' WX^3(RENV3)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDES, dwData)
        If (dwRet) Then
            hcp52c_SetOrgMode = dwRet
            Exit Function
        End If

        ' Orgmode9̎CCTR2͂w߈ʒuɂ
        ' (Orgmode9ȊO̎CCTR2͂͋@Bʒu)
        If (mode = 9) Then
            dwData = dwData And &HFFFFFCFF
            dwData = dwData Or &H100S
        End If
        dwData = dwData And &HFFFFFFF0
        dwData = dwData Or mode

        ' WX^3(RENV3)
        dwRet = cp52c_wReg(hDevID, axis, &H9ES, dwData)
        hcp52c_SetOrgMode = 0
    End Function

    ' \tg~bg̐ݒ
    ' FfoCXnhCC+SLSC-SLSCgpJE^C~@
    Public Function hcp52c_SetSls(ByVal hDevID As Integer, ByVal axis As Short, ByVal psls As Integer, ByVal msls As Integer, ByVal selctr As Short, ByVal st As Short) As Integer
        Dim dwRet As Integer ' ߂l
        Dim dwEnv As Integer

        ' ԍ0`11ȊO܂͎gpJE^0`4ȊO
        ' \tg~bggp+SLS < -SLS͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetSls = &H100S
            Exit Function
        End If

        If ((selctr < 0) Or (selctr > 4)) Then
            hcp52c_SetSls = &H100S
            Exit Function
        End If

        If (selctr) Then
            If (psls <= msls) Then
                hcp52c_SetSls = &H100S
                Exit Function
            End If
        End If

        dwRet = cp52c_rReg(hDevID, axis, &HDFS, dwEnv) ' RENV4Ǎ
        If (dwRet) Then
            hcp52c_SetSls = dwRet
            Exit Function
        End If

        If (selctr = 0) Then
            ' sgp
            dwEnv = dwEnv And &HFFFFE3E3 ' RENV4 ޯĸر
            dwRet = cp52c_wReg(hDevID, axis, &H9FS, dwEnv) ' RENV4 sgpݒ
            hcp52c_SetSls = dwRet
            Exit Function
        Else
            ' JE^̑I
            dwEnv = dwEnv And &HFFFF0000 ' RENV4 ޯĸر
            Select Case selctr ' RENV4 ޯĐݒ
                Case 1
                    dwEnv = dwEnv Or &H1818S ' 1
                Case 2
                    dwEnv = dwEnv Or &H1919S ' 2
                Case 3
                    dwEnv = dwEnv Or &H1A1AS ' 3
                Case 4
                    dwEnv = dwEnv Or &H1B1BS ' 4
            End Select
        End If

        ' ~@̑I
        If (st) Then
            dwEnv = dwEnv Or &H4040S ' ~
        Else
            dwEnv = dwEnv Or &H2020S ' ~
        End If

        ' WX^4(RENV4)
        dwRet = cp52c_wReg(hDevID, axis, &H9FS, dwEnv)
        If (dwRet) Then
            hcp52c_SetSls = dwRet
            Exit Function
        End If

        ' +SLSf[^ݒ
        dwRet = cp52c_wReg(hDevID, axis, &HA7S, psls)
        If (dwRet) Then
            hcp52c_SetSls = dwRet
            Exit Function
        End If

        ' -SLSf[^ݒ
        dwRet = cp52c_wReg(hDevID, axis, &HA8S, msls)
        If (dwRet) Then
            hcp52c_SetSls = dwRet
            Exit Function
        End If

        hcp52c_SetSls = 0
    End Function

    ' ELS̐ݒ
    ' FfoCXnhCCɐC~@
    Public Function hcp52c_SetEls(ByVal hDevID As Integer, ByVal axis As Short, ByVal pol As Short, ByVal st As Short) As Integer
        Dim wData As Short
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetEls = &H100S
            Exit Function
        End If

        ' ELSɐ|[gǍ
        wData = g_elspol(hDevID And &HFS)

        If (pol) Then
            wData = wData Or (2 ^ axis) ' A
        Else
            wData = wData And (Not (2 ^ axis)) ' B
        End If

        ' ELSɐ|[g
        dwRet = cp52c_wPortW(hDevID, CP52C_ELS_PRT, wData)
        If (dwRet) Then
            hcp52c_SetEls = dwRet
            Exit Function
        Else
            g_elspol(hDevID And &HFS) = wData
        End If

        ' WX^P(RENV1)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
        If (dwRet) Then
            hcp52c_SetEls = dwRet
            Exit Function
        End If

        If (st) Then
            dwData = dwData Or &H8S ' ~
        Else
            dwData = dwData And (Not &H8S) ' ~
        End If

        ' WX^P(RENV1)
        dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)

        hcp52c_SetEls = dwRet
    End Function

    ' OLS̐ݒ
    ' FfoCXnhCCɐ
    Public Function hcp52c_SetOls(ByVal hDevID As Integer, ByVal axis As Short, ByVal pol As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetOls = &H100S
            Exit Function
        End If

        ' WX^P(RENV1)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
        If (dwRet) Then
            hcp52c_SetOls = dwRet
            Exit Function
        End If

        If (pol) Then
            dwData = dwData Or &H80S ' A
        Else
            dwData = dwData And (Not &H80S) ' B
        End If

        ' WX^P(RENV1)
        dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)
        hcp52c_SetOls = dwRet
    End Function

    ' SVALM̐ݒ
    ' FfoCXnhCCɐC~@
    Public Function hcp52c_SetSvAlm(ByVal hDevID As Integer, ByVal axis As Short, ByVal pol As Short, ByVal st As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetSvAlm = &H100S
            Exit Function
        End If

        ' WX^P(RENV1)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
        If (dwRet) Then
            hcp52c_SetSvAlm = dwRet
            Exit Function
        End If

        If (pol) Then
            dwData = dwData Or &H200S ' A
        Else
            dwData = dwData And (Not &H200S) ' B
        End If

        If (st) Then
            dwData = dwData Or &H100S ' ~
        Else
            dwData = dwData And (Not &H100S) ' ~
        End If

        ' WX^P(RENV1)
        dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)
        hcp52c_SetSvAlm = dwRet
    End Function

    ' INPOS̐ݒ
    ' FfoCXnhCCgp/sgpCɐ
    Public Function hcp52c_SetInpos(ByVal hDevID As Integer, ByVal axis As Short, ByVal enable As Short, ByVal pol As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetInpos = &H100S
            Exit Function
        End If

        ' 샂[h(RMD)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HD7S, dwData)
        If (dwRet) Then
            hcp52c_SetInpos = dwRet
            Exit Function
        End If

        If (enable) Then
            dwData = dwData Or &H200S ' gp
        Else
            dwData = dwData And (Not &H200S) ' sgp
        End If

        ' 샂[h(PRMD)
        dwRet = cp52c_wReg(hDevID, axis, &H87S, dwData)
        If (dwRet) Then
            hcp52c_SetInpos = dwRet
            Exit Function
        End If

        If (enable) Then
            ' WX^P(RENV1)Ǎ
            dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
            If (dwRet) Then
                hcp52c_SetInpos = dwRet
                Exit Function
            End If

            If (pol) Then
                dwData = dwData Or &H400000 ' A
            Else
                dwData = dwData And (Not &H400000) ' B
            End If

            ' WX^P(RENV1)
            dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)
            If (dwRet) Then
                hcp52c_SetInpos = dwRet
                Exit Function
            End If
        Else
            hcp52c_SetInpos = dwRet
        End If
    End Function

    ' GR[_Z̐ݒ
    ' FfoCXnhCC_AŎgpy񐔁Cɐ
    Public Function hcp52c_SetEz(ByVal hDevID As Integer, ByVal axis As Short, ByVal count As Short, ByVal pol As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetEz = &H100S
            Exit Function
        End If

        ' _AŎgpZ
        count = count And &HFS

        ' WX^3(RENV3)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDES, dwData)
        If (dwRet) Then
            hcp52c_SetEz = dwRet
            Exit Function
        End If

        dwData = dwData And &HFFFFFF0F

        dwData = dwData Or (count * (2 ^ 4))

        ' WX^3(RENV3)
        dwRet = cp52c_wReg(hDevID, axis, &H9ES, dwData)
        If (dwRet) Then
            hcp52c_SetEz = dwRet
            Exit Function
        End If

        ' ɐI
        ' WX^Q(RENV2)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDDS, dwData)
        If (dwRet) Then
            hcp52c_SetEz = dwRet
            Exit Function
        End If

        If (pol) Then
            dwData = dwData Or &H800000 ' 
        Else
            dwData = dwData And (Not &H800000) ' オ
        End If

        ' WX^2(RENV2)
        dwRet = cp52c_wReg(hDevID, axis, &H9DS, dwData)
        hcp52c_SetEz = dwRet
    End Function

    ' T[{G[JE^NAo͂̐ݒ
    ' FfoCXnhCCgp@
    Public Function hcp52c_SetSvCtrCl(ByVal hDevID As Integer, ByVal axis As Short, ByVal enable As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' gp@0`3ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetSvCtrCl = &H100S
            Exit Function
        End If

        If ((enable < 0) Or (enable > 3)) Then
            hcp52c_SetSvCtrCl = &H100S
            Exit Function
        End If

        ' WX^P(RENV1)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
        If (dwRet) Then
            hcp52c_SetSvCtrCl = dwRet
            Exit Function
        End If


        dwData = dwData And (Not &HC00S)

        Select Case enable
            Case 0 ' sgp

            Case 1 ' _A
                dwData = dwData Or &H800S

            Case 2 ' ُ~
                dwData = dwData Or &H400S

            Case 3 ' _Ayшُ~
                dwData = dwData Or &HC00S

            Case Else
                hcp52c_SetSvCtrCl = &H100S
                Exit Function
        End Select

        ' WX^P(RENV1)
        dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)
        hcp52c_SetSvCtrCl = dwRet
    End Function

    ' w߃pX̏o͌`̐ݒ
    ' FfoCXnhCCw߃pX̏o͌`(ʃpX/ʃpX)
    Public Function hcp52c_SetCmdPulse(ByVal hDevID As Integer, ByVal axis As Short, ByVal cmdpls As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂͎w߃pX̏o͌`
        ' 0`3ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetCmdPulse = &H100S
            Exit Function
        End If

        If ((cmdpls < 0) Or (cmdpls > 3)) Then
            hcp52c_SetCmdPulse = &H100S
            Exit Function
        End If

        ' WX^P(RENV1)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HDCS, dwData)
        If (dwRet) Then
            hcp52c_SetCmdPulse = dwRet
            Exit Function
        End If

        dwData = dwData And &HFFFFFFF8

        Select Case cmdpls
            Case 0 ' 
                dwData = dwData Or &H4S
            Case 1 ' 
                dwData = dwData Or &H2S
            Case 2
                dwData = dwData Or &H7S
            Case 3
                dwData = dwData Or &H0S
            Case Else ' G[
                hcp52c_SetCmdPulse = &H100S
                Exit Function
        End Select

        ' WX^1(RENV1)
        dwRet = cp52c_wReg(hDevID, axis, &H9CS, dwData)
        hcp52c_SetCmdPulse = dwRet
    End Function

    ' `ݒ
    ' FfoCXnhCC`(/S)
    Public Function hcp52c_SetAccProfile(ByVal hDevID As Integer, ByVal axis As Short, ByVal accpro As Object) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetAccProfile = &H100S
            Exit Function
        End If

        ' 샂[h(RMD)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HD7S, dwData)
        If (dwRet) Then
            hcp52c_SetAccProfile = dwRet
            Exit Function
        End If

        If (accpro) Then
            dwData = dwData Or &H400S ' S
        Else
            dwData = dwData And (Not &H400S) ' 
        End If

        ' 샂[h(PRMD)
        dwRet = cp52c_wReg(hDevID, axis, &H87S, dwData)
        hcp52c_SetAccProfile = dwRet
    End Function

    ' _̐ݒ
    ' FfoCXnhCC_̐ݒ(/}jA)
    Public Function hcp52c_SetAutoDec(ByVal hDevID As Integer, ByVal axis As Short, ByVal para As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetAutoDec = &H100S
            Exit Function
        End If

        ' 샂[h(RMD)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HD7S, dwData)
        If (dwRet) Then
            hcp52c_SetAutoDec = dwRet
            Exit Function
        End If

        If (para) Then
            dwData = dwData Or &H2000S ' }jA
        Else
            dwData = dwData And (Not &H2000S) ' 
        End If

        ' 샂[h(PRMD)
        dwRet = cp52c_wReg(hDevID, axis, &H87S, dwData)
        hcp52c_SetAutoDec = dwRet
    End Function

    ' =======================================
    '               Ǎ݌n̊֐
    ' =======================================
    ' CXe[^XǍ
    ' FfoCXnhCCCXe[^X
    Public Function hcp52c_ReadMainSts(ByVal hDevID As Integer, ByVal axis As Short, ByRef msts As Short) As Integer
        Dim wData As Short
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadMainSts = &H100S
            Exit Function
        End If

        ' CXe[^XǍ
        dwRet = cp52c_rMstsW(hDevID, axis, wData)
        If (dwRet) Then
            hcp52c_ReadMainSts = dwRet
            Exit Function
        End If

        msts = wData

        hcp52c_ReadMainSts = 0
    End Function

    ' G[Xe[^XǍ
    ' FfoCXnhCCG[Xe[^X
    Public Function hcp52c_ReadErrorSts(ByVal hDevID As Integer, ByVal axis As Short, ByRef ests As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadErrorSts = &H100S
            Exit Function
        End If

        ' G[Xe[^XǍ
        dwRet = cp52c_rReg(hDevID, axis, &HF2S, dwData)
        If (dwRet) Then
            hcp52c_ReadErrorSts = dwRet
            Exit Function
        End If

        ests = dwData

        hcp52c_ReadErrorSts = 0
    End Function

    ' CxgXe[^XǍ
    ' FfoCXnhCCCxgXe[^X
    Public Function hcp52c_ReadEventSts(ByVal hDevID As Integer, ByVal axis As Short, ByRef ists As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadEventSts = &H100S
            Exit Function
        End If

        ' CxgXe[^XǍ
        dwRet = cp52c_rReg(hDevID, axis, &HF3S, dwData)
        If (dwRet) Then
            hcp52c_ReadEventSts = dwRet
            Exit Function
        End If

        ists = dwData

        hcp52c_ReadEventSts = 0
    End Function

    ' TuXe[^XǍ
    ' FfoCXnhCCTuXe[^X
    Public Function hcp52c_ReadSubSts(ByVal hDevID As Integer, ByVal axis As Short, ByRef ssts As Short) As Integer
        Dim wData As Short
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadSubSts = &H100S
            Exit Function
        End If

        ' TuXe[^XǍ
        dwRet = cp52c_rSstsW(hDevID, axis, wData)
        If (dwRet) Then
            hcp52c_ReadSubSts = dwRet
            Exit Function
        End If

        ssts = wData

        hcp52c_ReadSubSts = 0
    End Function

    ' gXe[^XǍ
    ' FfoCXnhCCgXe[^X
    Public Function hcp52c_ReadExSts(ByVal hDevID As Integer, ByVal axis As Short, ByRef exsts As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadExSts = &H100S
            Exit Function
        End If

        ' gXe[^XǍ
        dwRet = cp52c_rReg(hDevID, axis, &HF1S, dwData)
        If (dwRet) Then
            hcp52c_ReadExSts = dwRet
            Exit Function
        End If

        exsts = dwData

        hcp52c_ReadExSts = 0
    End Function

    ' xǍ
    ' FfoCXnhCCx
    Public Function hcp52c_ReadSpd(ByVal hDevID As Integer, ByVal axis As Short, ByRef spd As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadSpd = &H100S
            Exit Function
        End If

        ' xǍ
        dwRet = cp52c_rReg(hDevID, axis, &HF5S, dwData)
        If (dwRet) Then
            hcp52c_ReadSpd = dwRet
            Exit Function
        End If

        spd = dwData

        hcp52c_ReadSpd = 0
    End Function

    ' JE^Ǎ
    ' FfoCXnhCCǍJE^CJE^l
    Public Function hcp52c_ReadCtr(ByVal hDevID As Integer, ByVal axis As Short, ByVal selctr As Short, ByRef count As Integer) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' ǍJE^1`4ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_ReadCtr = &H100S
            Exit Function
        End If

        If ((selctr < 1) Or (selctr > 4)) Then
            hcp52c_ReadCtr = &H100S
            Exit Function
        End If

        ' JE^Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HE2S + selctr, dwData)
        If (dwRet) Then
            hcp52c_ReadCtr = dwRet
            Exit Function
        End If

        count = dwData

        hcp52c_ReadCtr = 0
    End Function

    ' =======================================
    '           ݒn̊֐
    ' =======================================
    ' Cxg}XN̐ݒ
    ' FfoCXnhCCCxg}XNf[^
    Public Function hcp52c_SetEventMask(ByVal hDevID As Integer, ByVal axis As Short, ByVal mask As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' Cxg}XNf[^
        ' 0`&H0003ffffȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetEventMask = &H100S
            Exit Function
        End If

        If (mask And &HFFFC0000) Then
            hcp52c_SetEventMask = &H100S
            Exit Function
        End If

        ' Cxg}XN(RIRQ)WX^̏
        dwRet = cp52c_wReg(hDevID, axis, &HACS, mask)
        hcp52c_SetEventMask = dwRet
    End Function

    ' x[Xx̐ݒ
    ' FfoCXnhCCx[XxWX^
    Public Function hcp52c_SetFLSpd(ByVal hDevID As Integer, ByVal axis As Short, ByVal spd As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' xWX^1`65535ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetFLSpd = &H100S
            Exit Function
        End If

        If ((spd <= 0) Or (65535 < spd)) Then
            hcp52c_SetFLSpd = &H100S
            Exit Function
        End If

        ' PRFL̏
        dwRet = cp52c_wReg(hDevID, axis, &H81S, spd)
        hcp52c_SetFLSpd = dwRet
    End Function

    ' ⏕x̐ݒ
    ' FfoCXnhCC⏕xWX^
    Public Function hcp52c_SetAuxSpd(ByVal hDevID As Integer, ByVal axis As Short, ByVal spd As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' xWX^1`65535ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetAuxSpd = &H100S
            Exit Function
        End If
        If ((spd <= 0) Or (65535 < spd)) Then
            hcp52c_SetAuxSpd = &H100S
            Exit Function
        End If

        ' RFȀ
        dwRet = cp52c_wReg(hDevID, axis, &H9BS, spd)
        hcp52c_SetAuxSpd = dwRet
    End Function

    ' [g̐ݒ
    ' FfoCXnhCC[g
    ' NbNg = 19660800Hz
    ' (b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
    ' r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800
    Public Function hcp52c_SetAccRate(ByVal hDevID As Integer, ByVal axis As Short, ByVal accrate As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' [g1`65535ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetAccRate = &H100S
            Exit Function
        End If

        If ((accrate = 0) Or (65535 < accrate)) Then
            hcp52c_SetAccRate = &H100S
            Exit Function
        End If

        ' PRUȐ
        dwRet = cp52c_wReg(hDevID, axis, &H83S, accrate)
        hcp52c_SetAccRate = dwRet
    End Function

    ' [g̐ݒ
    ' FfoCXnhCC[g
    Public Function hcp52c_SetDecRate(ByVal hDevID As Integer, ByVal axis As Short, ByVal decrate As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetDecRate = &H100S
            Exit Function
        End If
        If (decrate > 65535) Then
            hcp52c_SetDecRate = &H100S
            Exit Function
        End If

        ' PRDȐ
        dwRet = cp52c_wReg(hDevID, axis, &H84S, decrate)
        hcp52c_SetDecRate = dwRet
    End Function

    ' {ݒl(MG)̐ݒ
    ' FfoCXnhCC{ݒl(MG)
    ' MG = 300 / { - 1
    Public Function hcp52c_SetMult(ByVal hDevID As Integer, ByVal axis As Short, ByVal rmg As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' {ݒl1ȉ͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetMult = &H100S
            Exit Function
        End If

        If (rmg < 2) Then
            hcp52c_SetMult = &H100S
            Exit Function
        End If

        ' PRMG̏
        dwRet = cp52c_wReg(hDevID, axis, &H85S, rmg)
        hcp52c_SetMult = dwRet
    End Function

    ' _̐ݒ
    ' FfoCXnhCC_
    Public Function hcp52c_SetDecPoint(ByVal hDevID As Integer, ByVal axis As Short, ByVal dstnc As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_SetDecPoint = &H100S
            Exit Function
        End If

        ' PRDP̏
        dwRet = cp52c_wReg(hDevID, axis, &H86S, dstnc)
        hcp52c_SetDecPoint = dwRet
    End Function

    ' =======================================
    '            ^pݒn̊֐
    ' =======================================
    ' 샂[h
    ' FfoCXnhCC샂[h
    Public Function hcp52c_WritOpeMode(ByVal hDevID As Integer, ByVal axis As Short, ByVal mode As Short) As Integer
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' 샂[hُ͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_WritOpeMode = &H100S
            Exit Function
        End If

        If (mode And &HFF80S) Then
            hcp52c_WritOpeMode = &H100S
            Exit Function
        End If

        dwData = Val(Mid(MOD_TBL, CInt(mode + 1), 1))
        If (dwData = 0) Then
            hcp52c_WritOpeMode = &H100S
            Exit Function
        End If

        ' 샂[h(PRMD)Ǎ
        dwRet = cp52c_rReg(hDevID, axis, &HC7S, dwData)
        If (dwRet) Then
            hcp52c_WritOpeMode = dwRet
            Exit Function
        End If

        dwData = dwData And &HFFFFBF00

        If (mode = &H42S) Then
            dwData = dwData Or &H4041S
        Else
            dwData = dwData Or mode
        End If

        ' 샂[h(PRMD)
        dwRet = cp52c_wReg(hDevID, axis, &H87S, dwData)
        hcp52c_WritOpeMode = dwRet
    End Function

    ' 쑬xWX^̐ݒ
    ' FfoCXnhCC쑬xWX^
    Public Function hcp52c_WritFHSpd(ByVal hDevID As Integer, ByVal axis As Short, ByVal spd As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂
        ' xWX^1`65535ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_WritFHSpd = &H100S
            Exit Function
        End If

        If ((spd <= 0) Or (65535 < spd)) Then
            hcp52c_WritFHSpd = &H100S
            Exit Function
        End If

        ' PRFH̏
        dwRet = cp52c_wReg(hDevID, axis, &H82S, spd)
        hcp52c_WritFHSpd = dwRet
    End Function

    ' ʒu߈ړʂ̐ݒ
    ' FfoCXnhCCړ
    Public Function hcp52c_WritPos(ByVal hDevID As Integer, ByVal axis As Short, ByVal dstnc As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_WritPos = &H100S
            Exit Function
        End If

        If ((dstnc < -134217728) Or (134217727 < dstnc)) Then
            hcp52c_WritPos = &H100S
            Exit Function
        End If

        ' PRMV̏
        dwRet = cp52c_wReg(hDevID, axis, &H80S, dstnc)
        hcp52c_WritPos = dwRet
    End Function

    ' Ԃ̈ړʂ̐ݒ
    ' FfoCXnhCCړ
    Public Function hcp52c_WritLine(ByVal hDevID As Integer, ByVal axis As Short, ByVal dstnc As Integer) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO͈̎G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_WritLine = &H100S
            Exit Function
        End If

        If ((dstnc < -134217728) Or (134217727 < dstnc)) Then
            hcp52c_WritLine = &H100S
            Exit Function
        End If

        ' PRMV̏
        dwRet = cp52c_wReg(hDevID, axis, &H80S, dstnc)
        hcp52c_WritLine = dwRet
    End Function

    ' ~ʕԂ̃f[^ݒ
    ' FfoCXnhCgݍ킹CI_ʒu1CI_ʒu2CSʒu1CSʒu2
    Public Function hcp52c_WritCircl(ByVal hDevID As Integer, ByVal axis As Short, ByVal dstnc1 As Integer, ByVal dstnc2 As Integer, ByVal center1 As Integer, ByVal center2 As Integer) As Integer
        Dim dwRet As Integer ' ߂l
        Dim ax1 As Short
        Dim ax2 As Short

        ' Ԏ̑gݍ킹̈0`11ȊO̎̓G[
        If ((axis < 0) Or (17 < axis)) Then
            hcp52c_WritCircl = &H100S
            Exit Function
        End If
        If ((dstnc1 < -134217728) Or (134217727 < dstnc1)) Then
            hcp52c_WritCircl = &H100S
            Exit Function
        End If
        If ((dstnc2 < -134217728) Or (134217727 < dstnc2)) Then
            hcp52c_WritCircl = &H100S
            Exit Function
        End If
        If ((center1 < -134217728) Or (134217727 < center1)) Then
            hcp52c_WritCircl = &H100S
            Exit Function
        End If
        If ((center2 < -134217728) Or (134217727 < center2)) Then
            hcp52c_WritCircl = &H100S
            Exit Function
        End If

        Select Case axis
            Case 0 ' X1(0),  Y1(1)
                ax1 = 0
                ax2 = 1
            Case 1 ' X1(0),  Z1(2)
                ax1 = 0
                ax2 = 2
            Case 2 ' X1(0),  U1(3)
                ax1 = 0
                ax2 = 3
            Case 3 ' Y1(1),  Z1(2)
                ax1 = 1
                ax2 = 2
            Case 4 ' Y1(1),  U1(3)
                ax1 = 1
                ax2 = 3
            Case 5 ' Z1(2),  U1(3)
                ax1 = 2
                ax2 = 3
            Case 6 ' X2(4),  Y2(5)
                ax1 = 4
                ax2 = 5
            Case 7 ' X2(4),  Z2(6)
                ax1 = 4
                ax2 = 6
            Case 8 ' X2(4).  U2(7)
                ax1 = 4
                ax2 = 7
            Case 9 ' Y2(5),  Z2(6)
                ax1 = 5
                ax2 = 6
            Case 10 ' Y2(5),  U2(7)
                ax1 = 5
                ax2 = 7
            Case 11 ' Z2(6),  U2(7)
                ax1 = 6
                ax2 = 7
            Case 12 ' X3(8),  Y3(9)
                ax1 = 8
                ax2 = 9
            Case 13 ' X3(8),  Z3(10)
                ax1 = 8
                ax2 = 10
            Case 14 ' X3(8).  U3(11)
                ax1 = 8
                ax2 = 11
            Case 15 ' Y3(9),  Z3(10)
                ax1 = 9
                ax2 = 10
            Case 16 ' Y3(9),  U3(11)
                ax1 = 9
                ax2 = 11
            Case 17 ' Z3(10), U3(11)
                ax1 = 10
                ax2 = 11
        End Select
        ' PRMV(I_ʒu)̏
        dwRet = cp52c_wReg(hDevID, ax1, &H80S, dstnc1)
        If (dwRet) Then
            hcp52c_WritCircl = dwRet
            Exit Function
        End If
        dwRet = cp52c_wReg(hDevID, ax2, &H80S, dstnc2)
        If (dwRet) Then
            hcp52c_WritCircl = dwRet
            Exit Function
        End If
        ' PRIP(Sʒu)̏
        dwRet = cp52c_wReg(hDevID, ax1, &H88S, center1)
        If (dwRet) Then
            hcp52c_WritCircl = dwRet
            Exit Function
        End If
        dwRet = cp52c_wReg(hDevID, ax2, &H88S, center2)
        hcp52c_WritCircl = dwRet
    End Function

    ' JE^vZbg
    ' FfoCXnhC vZbglCJE^I
    Public Function hcp52c_WritCtr(ByVal hDevID As Integer, ByVal axis As Short, ByVal preset As Integer, ByVal selctr As Integer) As Integer
        Dim byCmd As Byte
        Dim dwRet As Integer ' ߂l

        ' ԍ0`11ȊO܂̓JE^1`4ȊO̎̓G[
        If ((axis < X1_AX) Or (U3_AX < axis)) Then
            hcp52c_WritCtr = &H100S
            Exit Function
        End If

        If ((selctr < 1) Or (4 < selctr)) Then
            hcp52c_WritCtr = &H100S
            Exit Function
        End If

        If ((preset < -134217728) Or (134217727 < preset)) Then
            hcp52c_WritCtr = &H100S
            Exit Function
        End If

        ' JE^I
        byCmd = (&HA2S + selctr)

        ' vZbgl
        dwRet = cp52c_wReg(hDevID, axis, byCmd, preset)

        hcp52c_WritCtr = dwRet
    End Function

    ' =======================================
    '            쐧n̊֐
    ' =======================================
    ' ~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_DecStop(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_DecStop = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɌ~
        If (axis And &HFS) Then
            dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H4AS)
        End If

        ' X2 - U2 : wQɌ~
        If ((axis And &HF0S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 4, (CShort(axis And &HF0S) * 16) Or &H4AS)
        End If

        ' X3 - U3 : wRɌ~
        If ((axis And &HF00S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 8, (axis And &HF00S) Or &H4AS)
        End If

        hcp52c_DecStop = dwRet
    End Function

    ' ~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_QuickStop(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_QuickStop = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɌ~
        If (axis And &HFS) Then
            dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H49S)
        End If

        ' X2 - U2 : wQɌ~
        If ((axis And &HF0S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 4, (CShort(axis And &HF0S) * 16) Or &H49S)
        End If

        ' X3 - U3 : wRɌ~
        If ((axis And &HF00S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 8, (axis And &HF00S) Or &H49S)
        End If

        hcp52c_QuickStop = dwRet
    End Function

    ' ~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_EmgStop(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_EmgStop = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɔ~
        If (axis And &HFS) Then
            dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H5S)
        End If

        ' X2 - U2 : wQɔ~
        If ((axis And &HF0S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 4, (CShort(axis And &HF0S) * 16) Or &H5S)
        End If

        ' X3 - U3 : wRɔ~
        If ((axis And &HF00S) And (Not dwRet)) Then
            dwRet = cp52c_wCmdW(hDevID, 8, (axis And &HF00S) Or &H5S)
        End If

        hcp52c_EmgStop = dwRet
    End Function

    ' ~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SyDecStop(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wAx As Short
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_SyDecStop = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S


        For wAx = 0 To 11
            If (axis And axbit(wAx)) Then
                ' ~:wߎ
                ' WX^P(RENV1): ~
                dwRet = cp52c_rReg(hDevID, wAx, &HDCS, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
                dwData = dwData Or &H80000 ' ~
                dwRet = cp52c_wReg(hDevID, wAx, &H9CS, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
                ' 샂[h(RMD): ~
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
                dwData = dwData Or &H1000000
                dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
            Else
                ' ~:wߎ
                ' 샂[h(RMD): ~ݾ
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
                dwData = dwData And (Not &H1000000)
                dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
            End If
        Next wAx

        dwRet = cp52c_wCmdW(hDevID, 0, &H7S) ' X1FR}h

        ' 샂[h(RMD): ~ݾ
        For wAx = 0 To 12
            If (axis And axbit(wAx)) Then
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
                dwData = dwData And (Not &H1000000)
                dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwData)
                If (dwRet) Then
                    hcp52c_SyDecStop = dwRet
                    Exit Function
                End If
            End If
        Next wAx
        hcp52c_SyDecStop = dwRet
    End Function

    ' ~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SyQuickStop(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wAx As Short
        Dim dwData As Integer
        Dim dwRet As Integer ' ߂l
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_SyQuickStop = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S


        For wAx = 0 To 11
            If (axis And axbit(wAx)) Then
                ' ~:wߎ
                ' WX^P(RENV1): ~
                dwRet = cp52c_rReg(hDevID, wAx, &HDCS, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
                dwData = dwData And (Not &H80000) ' ~
                dwRet = cp52c_wReg(hDevID, wAx, &H9CS, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
                ' 샂[h(RMD): ~
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
                dwData = dwData Or &H1000000
                dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
            Else
                ' ~:wߎ
                ' 샂[h(RMD): ~ݾ
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
                dwData = dwData And (Not &H1000000)
                dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
            End If
        Next wAx

        dwRet = cp52c_wCmdW(hDevID, 0, &H7S) ' X1FR}h

        ' 샂[h(RMD): ~ݾ
        For wAx = 0 To 12
            If (axis And axbit(wAx)) Then
                dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
                dwData = dwData And (Not &H1000000)
                dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwData)
                If (dwRet) Then
                    hcp52c_SyQuickStop = dwRet
                    Exit Function
                End If
            End If
        Next wAx
        hcp52c_SyQuickStop = dwRet
    End Function

    ' X^[g
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_AccStart(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wCmd As Short
        Dim wAx As Short
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer
        Dim dwRmd(12) As Integer
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_AccStart = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S

        If ((axis And &HFF0S) = 0) Then ' X1-U1̂
            wCmd = (axis * &H100S) Or &H53S
            dwRet = cp52c_wCmdW(hDevID, 0, wCmd) ' X1R}h
        ElseIf ((axis And &HF0FS) = 0) Then  ' X2-U2̂
            wCmd = (axis * &H10S) Or &H53S
            dwRet = cp52c_wCmdW(hDevID, 4, wCmd) ' X2R}h
        ElseIf ((axis And &HFFS) = 0) Then  ' X3-U3̂
            wCmd = axis Or &H53S
            dwRet = cp52c_wCmdW(hDevID, 8, wCmd) ' X3R}h
        Else ' X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' :wߎ
                    ' 샂[h(RMD): 
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_AccStart = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) Or &H40000
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_AccStart = dwRet
                        Exit Function
                    End If
                    dwRet = cp52c_wCmdW(hDevID, wAx, &H53S) ' ĺޏ
                Else
                    ' :wߎ
                    ' 샂[h(RMD): (񓯎)
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_AccStart = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) And (Not (&HC0000))
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_AccStart = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
            dwRet = cp52c_wCmdW(hDevID, 0, &H6S) ' X1:STAMo

            ' 샂[hɖ߂
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' 샂[h(PRMD)
                    dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_AccStart = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
        End If
        hcp52c_AccStart = dwRet
    End Function

    ' FH葬X^[g
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_CnstStartFH(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wCmd As Short
        Dim wAx As Short
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer
        Dim dwRmd(12) As Integer
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_CnstStartFH = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S

        If ((axis And &HFF0S) = 0) Then ' X1-U1̂
            wCmd = (axis * &H100S) Or &H51S
            dwRet = cp52c_wCmdW(hDevID, 0, wCmd) ' X1R}h
        ElseIf ((axis And &HF0FS) = 0) Then  ' X2-U2̂
            wCmd = (axis * &H10S) Or &H51S
            dwRet = cp52c_wCmdW(hDevID, 4, wCmd) ' X2R}h
        ElseIf ((axis And &HFFS) = 0) Then  ' X3-U3̂
            wCmd = axis Or &H51S
            dwRet = cp52c_wCmdW(hDevID, 8, wCmd) ' X3R}h
        Else ' X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' FH葬:wߎ
                    ' 샂[h(RMD): 
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFH = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) Or &H40000
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartFH = dwRet
                        Exit Function
                    End If
                    dwRet = cp52c_wCmdW(hDevID, wAx, &H51S) ' ĺޏ
                Else
                    ' FH葬:wߎ
                    ' 샂[h(RMD): (񓯎)
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFH = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) And (Not (&HC0000))
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartFH = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
            dwRet = cp52c_wCmdW(hDevID, 0, &H6S) ' X1:STAMo

            ' 샂[hɖ߂
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' 샂[h(PRMD)
                    dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFH = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
        End If
        hcp52c_CnstStartFH = dwRet
    End Function

    ' FL葬X^[g
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_CnstStartFL(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wCmd As Short
        Dim wAx As Short
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer
        Dim dwRmd(12) As Integer
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_CnstStartFL = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S

        If ((axis And &HFF0S) = 0) Then ' X1-U1̂
            wCmd = (axis * &H100S) Or &H50S
            dwRet = cp52c_wCmdW(hDevID, 0, wCmd) ' X1R}h
        ElseIf ((axis And &HF0FS) = 0) Then  ' X2-U2̂
            wCmd = (axis * &H10S) Or &H50S
            dwRet = cp52c_wCmdW(hDevID, 4, wCmd) ' X2R}h
        ElseIf ((axis And &HFFS) = 0) Then  ' X3-U3̂
            wCmd = axis Or &H50S
            dwRet = cp52c_wCmdW(hDevID, 8, wCmd) ' X3R}h
        Else ' X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' FL葬:wߎ
                    ' 샂[h(RMD): 
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFL = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) Or &H40000
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartFL = dwRet
                        Exit Function
                    End If
                    dwRet = cp52c_wCmdW(hDevID, wAx, &H50S) ' ĺޏ
                Else
                    ' FL葬:wߎ
                    ' 샂[h(RMD): (񓯎)
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFL = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) And (Not (&HC0000))
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartFL = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
            dwRet = cp52c_wCmdW(hDevID, 0, &H6S) ' X1:STAMo

            ' 샂[hɖ߂
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' 샂[h(PRMD)
                    dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartFL = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
        End If
        hcp52c_CnstStartFL = dwRet
    End Function

    ' FH葬X^[g㌸~
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_CnstStartByDec(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim wCmd As Short
        Dim wAx As Short
        Dim dwRet As Integer ' ߂l
        Dim dwData As Integer
        Dim dwRmd(12) As Integer
        Dim axbit(12) As Short

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_CnstStartByDec = &H100S
            Exit Function
        End If

        axbit(0) = 1
        axbit(1) = 2
        axbit(2) = 4
        axbit(3) = 8
        axbit(4) = &H10S
        axbit(5) = &H20S
        axbit(6) = &H40S
        axbit(7) = &H80S
        axbit(8) = &H100S
        axbit(9) = &H200S
        axbit(10) = &H400S
        axbit(11) = &H800S

        If ((axis And &HFF0S) = 0) Then ' X1-U1̂
            wCmd = (axis * &H100S) Or &H52S
            dwRet = cp52c_wCmdW(hDevID, 0, wCmd) ' X1R}h
        ElseIf ((axis And &HF0FS) = 0) Then  ' X2-U2̂
            wCmd = (axis * &H10S) Or &H52S
            dwRet = cp52c_wCmdW(hDevID, 4, wCmd) ' X2R}h
        ElseIf ((axis And &HFFS) = 0) Then  ' X3-U3̂
            wCmd = axis Or &H52S
            dwRet = cp52c_wCmdW(hDevID, 8, wCmd) ' X3R}h
        Else ' X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' FH葬X^[g㌸~:wߎ
                    ' 샂[h(RMD): 
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartByDec = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) Or &H40000
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartByDec = dwRet
                        Exit Function
                    End If
                    dwRet = cp52c_wCmdW(hDevID, wAx, &H52S) ' ĺޏ
                Else
                    ' FH葬X^[g㌸~:wߎ
                    ' 샂[h(RMD): (񓯎)
                    dwRet = cp52c_rReg(hDevID, wAx, &HD7S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartByDec = dwRet
                        Exit Function
                    End If
                    dwData = dwRmd(wAx) And (Not (&HC0000))
                    dwRet = cp52c_wReg(hDevID, wAx, &H97S, dwData)
                    If (dwRet) Then
                        hcp52c_CnstStartByDec = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
            dwRet = cp52c_wCmdW(hDevID, 0, &H6S) ' X1:STAMo

            ' 샂[hɖ߂
            For wAx = 0 To 11
                If (axis And axbit(wAx)) Then
                    ' 샂[h(PRMD)
                    dwRet = cp52c_wReg(hDevID, wAx, &H87S, dwRmd(wAx))
                    If (dwRet) Then
                        hcp52c_CnstStartByDec = dwRet
                        Exit Function
                    End If
                End If
            Next wAx
        End If
        hcp52c_CnstStartByDec = dwRet
    End Function

    ' T[{I
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SvOn(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFȊO̎̓G[
        If ((axis <= 0) Or (&HFS < axis)) Then
            hcp52c_SvOn = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃT[{I
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H18S)

        hcp52c_SvOn = dwRet
    End Function

    ' T[{It
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SvOff(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFȊO̎̓G[
        If ((axis <= 0) Or (&HFS < axis)) Then
            hcp52c_SvOff = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃT[{It
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H10S)

        hcp52c_SvOff = dwRet
    End Function

    ' T[{ZbgI
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SvResetOn(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFȊO̎̓G[
        If ((axis <= 0) Or (&HFS < axis)) Then
            hcp52c_SvResetOn = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃT[{ZbgI
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H19S)

        hcp52c_SvResetOn = dwRet
    End Function

    ' T[{ZbgIt
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_SvResetOff(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFȊO̎̓G[
        If ((axis <= 0) Or (&HFS < axis)) Then
            hcp52c_SvResetOff = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃT[{ZbgIt
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H11S)

        hcp52c_SvResetOff = dwRet
    End Function

    ' pX[^I
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_PMOn(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFFFȊO̎̓G[
        If ((axis <= 0) Or (&HFFFS < axis)) Then
            hcp52c_PMOn = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃpX[^I
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H10S)

        hcp52c_PMOn = dwRet
    End Function

    ' pX[^It
    ' FfoCXnhCgݍ킹(HEX)
    Public Function hcp52c_PMOff(ByVal hDevID As Integer, ByVal axis As Short) As Integer
        Dim dwRet As Integer ' ߂l

        ' ԍ&H1`&HFȊO̎̓G[
        If ((axis <= 0) Or (&HFS < axis)) Then
            hcp52c_PMOff = &H100S
            Exit Function
        End If

        ' X1 - U1 : wPɃpX[^It
        dwRet = cp52c_wCmdW(hDevID, 0, (CShort(axis And &HFS) * 256) Or &H18S)

        hcp52c_PMOff = dwRet
    End Function

    ' [ǧvZ
    ' F[gCԁCegCekC`C\
    'UPGRADE_NOTE: rate  rate_Renamed ɃAbvO[h܂B ڍׂɂẮA'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"' NbNĂB
    Public Function hcp52c_CalAccRate(ByRef rate_Renamed As Integer, ByVal dwtime As Integer, ByVal fh As Integer, ByVal fl As Integer, ByVal pro As Short, ByVal s As Short) As Integer
        Dim dblData As Double
        Dim dblTime As Double

        If (fh = 0) Then
            hcp52c_CalAccRate = &H100S
            Exit Function
        End If

        If (fl = 0) Then
            hcp52c_CalAccRate = &H100S
            Exit Function
        End If

        If (fh <= fl) Then
            hcp52c_CalAccRate = &H100S
            Exit Function
        End If

        If (dwtime = 0) Then
            hcp52c_CalAccRate = &H100S
            Exit Function
        End If

        dblTime = dwtime / 1000 ' (b)

        If (s) Then
            ' ̂r[g:PRUR = 4915200 * ( / (FH - FL)) - 1)
            dblData = dblTime / (System.Math.Abs(fh - fl + 2 * s))
            dblData = 4915200 * dblData - 1
            rate_Renamed = dblData
        Else
            If (pro) Then
                ' ̂Ȃr[g:PRUR = 2457600 * ( / (FH - FL)) - 1)
                dblData = dblTime / (System.Math.Abs(fh - fl))
                dblData = 2457600 * dblData - 1
                rate_Renamed = dblData
            Else
                ' [g:PRUR = 4915200 * ( / (FH - FL)) - 1)
                dblData = dblTime / (System.Math.Abs(fh - fl))
                dblData = 4915200 * dblData - 1
                rate_Renamed = dblData
            End If
        End If

        If (rate_Renamed > 65535) Or (rate_Renamed <= 0) Then
            hcp52c_CalAccRate = &H100S
        Else
            hcp52c_CalAccRate = 0
        End If
    End Function

End Module
