//
// s1_dev.c
//
#include <windows.h>
#include "resource.h"
#include "cp52cl1a.h"
#include "spc52c00.h"

LRESULT devMenu( HWND, UINT, WPARAM, LPARAM );
void HexAtoL( char*, DWORD* );

BOOL CALLBACK devProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( uMessage ) {
		// 
		case WM_SHOWWINDOW:
			hDev = 0xffffffff;
			break;	

		case WM_COMMAND:
			devMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		/* I */
		case WM_CLOSE:
			closeDev( hWnd );
			DestroyWindow( hWnd );					// _CAO{bNX
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;

		/* I */
		case WM_DESTROY:
			gDlg = NULL;
			break;
	}
	return 0 ;
}

LRESULT devMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD		dwRet = 0;
	DWORD		dwBrdID;
	DWORD		dwAdrs = 0;
	DWORD		dwCnt = 0;
	WORD		wIx;
	char		szBuf[255];
	
	switch( wParam ) {
		/* {[hID擾 */
		case IDC_BTN_INF:
			/* {[h & foCX擾 */
			dwRet = hcp52c_GetDevInfo(&gCnt, &gHpcDevInfo[0]);
			if (dwRet) {
				wsprintf( szBuf, "foCX񂪎擾ł܂\n߂lF%04Xh", dwRet );
				MessageBox(hWnd, szBuf, "", MB_OK);
				return 1;
			}

			/* R{{bNX̓eZbg */
			gCmb = GetDlgItem(hWnd, IDC_CMB_ID);
			SendMessage(gCmb, CB_RESETCONTENT, 0l, 0l);

			/* R{{bNXɃeLXgACeǉ */
			for (wIx = 0; wIx < gCnt; wIx++) {
				wsprintf(szBuf, "%d", gHpcDevInfo[wIx].dwBoardID );
				SendMessage(gCmb, CB_ADDSTRING, 0, (LPARAM)szBuf);
			}
			SendMessage(gCmb, CB_SETCURSEL, 0, 0);

			/* ʕ\ */
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_OPN), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CMB_ID),  TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_INF), FALSE);
			break;

		/* foCXI[v */
		case IDC_BTN_OPN:
			/* {[hw */
			GetDlgItemText(hWnd, IDC_CMB_ID, szBuf, 3); 	
			dwBrdID = atol(szBuf);
			for(wIx = 0; wIx < gCnt; wIx++) {
				if(gHpcDevInfo[wIx].dwBoardID == dwBrdID) {
					gHpcDevInfo2 = gHpcDevInfo[wIx];
					break;
				}
			}
			
			/* foCXI[v */
			dwRet = hcp52c_DevOpen(&hDev, &gHpcDevInfo2);
			if(dwRet) {
				wsprintf( szBuf, "foCXI[vł܂.\n߂lF%04Xh", dwRet );
				MessageBox(hWnd, szBuf, "", MB_OK);
				return dwRet;
			}

			/* foCXnh\ */
			wsprintf(szBuf, "%s%08lXh", "foCXnhF", hDev);
			SetDlgItemText(hWnd, IDC_STA_HNDL, szBuf);

			/* foCX\ */
			wsprintf(szBuf, "%s\n%s%ld\n%s%ld\n%s%08x\n%s%08x\n%s%08x\n%s%ld\n%s%ld\n%s%ld",	
					"@foCX@",
					"oXԍ@@@@F", gHpcDevInfo2.dwBusNumber,
					"foCXԍ@@F", gHpcDevInfo2.dwDeviceNumber,
					"x[XAhXQF", gHpcDevInfo2.dwBaseAddress2,
					"x[XAhXRF", gHpcDevInfo2.dwBaseAddress3,
					"x[XAhXSF", gHpcDevInfo2.dwBaseAddress4,
					"hqpԍ@@@F", gHpcDevInfo2.dwIrqNo,
					"Ǘԍ@@@@F", gHpcDevInfo2.dwNumber,
					"{[hhc@@@F", gHpcDevInfo2.dwBoardID);
			SetDlgItemText( hWnd, IDC_STA_DEV, szBuf );
			
			/* ʕ\ */
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_OPN), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_INF), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_CMB_ID), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_CLS), TRUE );					
			break;

		/* foCXN[Y */
		case IDC_BTN_CLS:
			/* foCXN[Y */
			hcp52c_DevClose(hDev);

			/* foCXnh\ */
			SetDlgItemText(hWnd, IDC_STA_HNDL, NULL);

			/* foCX\ */
			SetDlgItemText(hWnd, IDC_STA_DEV, NULL);

			/* ʕ\ */
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_OPN), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_INF), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CMB_ID), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_CLS), FALSE);	
			break;
	}
	return 0;
}

//	 16i̒lϊ
//	pszStr | 
//	pdwVal | l 
void HexAtoL(char * pszStr, DWORD * pdwVal)
{
	DWORD	dwVal = 0;
	char *	pszW;

	pszW = pszStr;
	while( *pszW ) {
		if	   ( *pszW >= '0' && *pszW <= '9' ) dwVal = (dwVal * 0x10)+( *pszW - '0');
		else if( *pszW >= 'a' && *pszW <= 'f' ) dwVal = (dwVal * 0x10)+((*pszW - 'a') + 10);
		else if( *pszW >= 'A' && *pszW <= 'F' ) dwVal = (dwVal * 0x10)+((*pszW - 'A') + 10);
		else	break;
		pszW++;
	}
	( *pdwVal ) = dwVal;
	return;
}